#include "AutoboxD.h"
#include "Control.h"
#include <qapplication.h>

#define Inherited AutoboxDData

AutoboxD::AutoboxD(QWidget* parent,const char* name):Inherited( parent, name )
{
	setCaption( "Autoboxer Threshold Selection" );
	connect(threshold,SIGNAL(sliderReleased()),this,SLOT(newVal()));
	connect(threshold2,SIGNAL(sliderReleased()),this,SLOT(newVal()));
	connect(threshold3,SIGNAL(sliderReleased()),this,SLOT(newVal()));
	connect(threshold4,SIGNAL(sliderReleased()),this,SLOT(newVal()));
	connect(ok,SIGNAL(clicked()),this,SLOT(Ok()));
	connect(cancel,SIGNAL(clicked()),this,SLOT(Cancel()));
}


AutoboxD::~AutoboxD()
{
if (map) delete map;
}

void AutoboxD::setup(int x,int y,float Min, float Max, EMData *Map, Control *tgt) {
min=Min;
max=Max;
map=Map;
target=tgt;
x0=x;
y0=y;

threshold->setValue(750);
threshold2->setValue(0);
threshold3->setValue(0);
threshold4->setValue(0);
newVal();
}

void AutoboxD::Ok() {
hide();
target->autoBox2(val);
delete this;
}

void AutoboxD::Cancel() {
delete this;
return;
}

void AutoboxD::newVal() {
target->delAll();
val[0]=(max-min)*threshold->value()/1000.0+min;
val[1]=threshold2->value()/500.0-1.0;
val[2]=threshold3->value()/500.0-1.0;
val[3]=threshold4->value()/500.0-1.0;
QApplication::setOverrideCursor( waitCursor );
target->boxesFrom(map,x0,y0,0,0,val);
QApplication::setOverrideCursor( arrowCursor );
}
