#include "Image.h"

Image::Image(QWidget* parent,const char* name):QWidget( parent, name )
{
initMetaObject();

qp=new QPainter();
qpm=new QPixmap(size());
qpd=NULL;

data=NULL;

setBackgroundMode(NoBackground);

rad=rad2=-1;
needupd=1;
}


Image::~Image()
{
delete qp;
delete qpm;
}

void Image::resizeEvent ( QResizeEvent *qe )
{
/*qp->begin(this);
qp->eraseRect(qp->window());
qp->end();
*/
qpm->resize(size());
needupd=1;
}

void Image::paintEvent( QPaintEvent *pe )
{
char *d;
float scale=1.0;
int i,sz;

sz=width()<height()?width():height();
if (data) scale=(float)sz/data->xSize();

if (needupd||qpd) {
	if (!data) {
		qpm->fill();
	}
	else {
		qpm->fill();

		d=(char *)calloc(1,width()*height()+80);

		sprintf(d,"P5\n%d %d\n255\n",width(),height());
		i=strlen(d);
		data->renderAmp8((unsigned char *)d+i,0,-1,width(),height(),width(),
			scale,1,254,data->Min(),data->ufloat);
//printf("%f %f %f %f\n",data->Min(),data->Max(),data->Mean(),data->Sigma());
		qpm->loadFromData((uchar *)d,(uint)(i+height()*width()));

		free(d);
		needupd=0;

		if (qpd) qp->begin(qpd);
	}
}

bitBlt( this, 0,0, qpm );

if (!qpd) qp->begin(this);
qp->setPen(red);

if (rad>0) {
	char s[50];
	sprintf(s,"r = %f pix",rad/scale);
	qp->drawText(6,18,s);
	qp->translate((sz-(int)scale)/2,height()-sz/2);
	qp->rotate(ang+90.0);
//	qp->drawEllipse(sz/2-rad,height()-(sz/2-rad2),rad*2,-rad2*2);
	qp->drawEllipse(-rad,-rad2,rad*2,rad2*2);
	qp->resetXForm();
}
qp->end();
}

void Image::mousePressEvent(QMouseEvent *e) {
int x,y;

x=e->x();
y=e->y();

//mouseMoveEvent(e);

update();
}

void Image::mouseReleaseEvent(QMouseEvent *e) {
int x,y;
int *a,b;

x=e->x();
y=e->y();

}

void Image::mouseMoveEvent(QMouseEvent *e) {
int x,y,sz,nx;
float *d,az,r,a=0,c=0,scale;

x=e->x();
y=e->y();

sz=width()<height()?width():height();
if (data) scale=(float)sz/(float)data->xSize();
else scale=1.0;

if ((e->state()&RightButton) && data) {
	r=floor(hypot(x-(sz/2+1-scale/2),y-(height()-sz/2+1)))/scale;
	if (r<1.0||r>=data->ySize()/2) return;
	nx=data->xSize();
	d=data->getDataRO();

	a=0;
	for (az=0; az<PI; az+=1.0/(r*PI)) {
		x=(int)floor(r*sin(az))*2;
		y=(int)floor(r*cos(az)+data->ySize()/2);
		a+=d[x+y*nx];
		c+=1.0;
//		if (d[x+y*nx]>a) a=d[x+y*nx];
	}
	data->doneData();
	data->ufloat=1.4*a/c;
	needupd=1;
	update();
	return;
}
else if ((e->state()&MidButton)) {
	rad2=floor(hypot(x-(sz/2+1-scale/2),y-(height()-sz/2+1)));
	if (rad2>rad) rad2=rad;
	ang=atan2(y-(height()-sz/2+1),x-(sz/2+1-scale/2))*180.0/PI;
	emit(sChange(rad/scale,rad2/scale,ang));
	update();
}
else {
	rad=rad2=floor(hypot(x-(sz/2+1-scale/2),y-(height()-sz/2+1)));
	ang=atan2(y-(height()-sz/2+1),x-(sz/2+1-scale/2))*180.0/PI;
	emit(sChange(rad/scale,rad2/scale,ang));
	update();
}
}

void Image::setRad(float r,float r2,float a) {
int sz;
float scale;

if (!data) { rad=-1; return; }
sz=width()<height()?width():height();
scale=(float)sz/(float)data->xSize();

rad=r*scale;
rad2=r2*scale;
ang=a;
update();
//printf("%f\n",r*scale);
}

void Image::print(QPaintDevice *dev) {
int x,y;

update();
}

void Image::setData(EMData *d) {
if (d && d->zSize()>1) { data=NULL; needupd=1; update(); return; }

data=d; 
if (d && data->ufloat==0) data->ufloat=data->Mean()+data->Sigma()*3.0;
needupd=1;
update();
}

void Image::mouseDoubleClickEvent(QMouseEvent *e) { };
void Image::mouseEnter(int) { };
void Image::mouseLeave(int) { };
void Image::keyPressEvent(QKeyEvent *) { };
void Image::keyReleaseEvent(QKeyEvent *) { };


void Image::imageChanged() { }
