#ifndef IMAGEH
#define IMAGEH

#include <stdio.h>
#include <qwidget.h>
#include <qpixmap.h>
#include <qpainter.h>
#include <qfont.h> 
#include <qfontmet.h> 
#include <qdict.h>
#include <qintdict.h>
#include <qlist.h>
#include "EMData.h"

class Image:public QWidget {
    Q_OBJECT

QPainter *qp;
QPaintDevice *qpd;
QPixmap *qpm;

EMData *data;

int needupd;
int rad,rad2;
float ang;

public:

			
Image( QWidget *parent=0, const char *name=0 );
~Image();

void setData(EMData *d);
EMData *getData();

virtual void paintEvent( QPaintEvent *qp );
virtual void mousePressEvent(QMouseEvent *);
virtual void mouseReleaseEvent(QMouseEvent *);
virtual void mouseDoubleClickEvent(QMouseEvent *e);
virtual void mouseMoveEvent(QMouseEvent *);
virtual void mouseEnter(int);
virtual void mouseLeave(int);
virtual void keyPressEvent(QKeyEvent *);
virtual void keyReleaseEvent(QKeyEvent *);
virtual void resizeEvent ( QResizeEvent * );
virtual void print(QPaintDevice *dev);

signals:
	void	changed();
	void	sChange(float r,float r2,float ang);
	void	newBox(QRect *r);

public slots:
	void	imageChanged();
	void	setRad(float,float,float);
};

inline EMData *Image::getData() { return data; }

#endif
