#include "InspCls.h"

#define Inherited InspClsData

InspCls::InspCls(QWidget* parent,const char* name):Inherited( parent, name ) {

mode=mmode=0;
im1=new EMData;
im2=new EMData;
im3=new EMData;
swap=0;

//connect(brite,SIGNAL(valueChanged(int)),this,SLOT(newBC(int)));
//connect(cont,SIGNAL(valueChanged(int)),this,SLOT(newBC(int)));
connect(imgn,SIGNAL(valueChanged(int)),this,SLOT(update(int)));
connect(imgn2,SIGNAL(valueChanged(int)),this,SLOT(update(int)));
connect(gobut,SIGNAL(clicked()),this,SLOT(go()));
connect(Mode,SIGNAL(activated(int)),SLOT(newMode(int)));
connect(MMode,SIGNAL(activated(int)),SLOT(newMidMode(int)));
}


InspCls::~InspCls() {
if (im1) delete im1;
if (im2) delete im2;
if (im3) delete im3;
}

void InspCls::setFile(const char *file) {
int n;

filespec=file;
if (filespec.contains("/classes")|| strncmp(filespec,"classes",7)==0) {
	Mode->setCurrentItem(2);
	newMode(2);
}
else if (filespec.contains("/cls") || strncmp(filespec,"cls",3)==0 ) {
	Mode->setCurrentItem(1);
	newMode(1);
}
else {
	Mode->setCurrentItem(0);
	newMode(0);
}

}

void InspCls::newMode(int m) {
int n;

mode=m;

switch (mode) {
case CLS_CLASSES:
	n=fileCount(filespec)/2;
	imgn->setRange(0,n-1);
	imgn->show();
	imgn2->hide();
	imgn->setValue(0);
	if (n>1) imgn2->setValue(1);
	MMode->setCurrentItem(1);
	newMidMode(1);
	break;
case CLS_CLS:
	n=fileCount(filespec);
	imgn->hide();
	imgn2->show();
	imgn2->setRange(n>1?1:0,n-1);
	imgn->setValue(0);
	if (n>1) imgn2->setValue(1);
	MMode->setCurrentItem(1);
	newMidMode(1);
	break;
case CLS_GEN:
	n=fileCount(filespec);
	imgn->show();
	imgn2->show();
	imgn->setRange(0,n-1);
	imgn2->setRange(0,n-1);
	imgn->setValue(0);
	if (n>1) imgn2->setValue(1);	
	MMode->setCurrentItem(0);
	newMidMode(0);
	break;
}

}

void InspCls::newMidMode(int m) {
mmode=m;

switch (mmode) {
case DIFF:
	break;
case DIFFA:
	break;
case SWAP:
	break;
case ANIM:
	break;

}
update(0);
}

void InspCls::go() {
swap^=1;
update(0);
}

void InspCls::update(int n) {
EMData *tmp;
int n1,n2;

n1=imgn->value();
n2=imgn2->value();

if (mode==CLS_CLASSES) {
	im1->readImage(filespec,n1*2);
	if (im3->readImage(filespec,n1*2+1)) im3->readImage(filespec,n1*2);
}
else {
	im1->readImage(filespec,n1);
	im3->readImage(filespec,n2);
}

switch (mmode) {
case DIFFA:
	tmp=im3->RTFAlign(im1,NULL,1);
	delete im3;
	im3=tmp;
case DIFF:
	delete im2;
	im2=im1->copy(0,0);
//	im2->normalizeTo(im3);
	im2->subtract(im3);
	break;
case SWAP:
	if (swap) { delete im2; im2=im3->copy(0,0); }
	else { delete im2; im2=im1->copy(0,0); }
	break;
case ANIM:
	break;
case CCF:
	delete im2;
	im2=im1->calcCCF(im3);
	im2->toCorner();
	break;
case RCCF:
	delete im2;
	if (swap) im2=im3->makeRFP()->copy();
	else im2=im1->makeRFP()->copy();
	break;
}

image1->setData(im1);
image2->setData(im2);
image3->setData(im3);

}
