#ifndef TRIVH
#define TRIVH

#include <stdio.h>
#include <qwidget.h>
#include <qpixmap.h>
#include <qpainter.h>
#include <qfont.h> 
#include <qfontmet.h> 
#include <qdict.h>
#include <qintdict.h>
#include <qlist.h>
#include "EMData.h"
#include "Euler.h"

struct TriPoint { float x, y, val; int map; };

class TriView:public QWidget {
    Q_OBJECT

QPainter *qp;
QPixmap *qpm;

float x0,x1,y0,y1;
float vmin,vmax;

QList<TriPoint> points;
int selpoint;

int needupd;
int colormode;

public:
			
TriView( QWidget *parent=0, const char *name=0 );
~TriView();

void setXRange(float min,float max);
void setYRange(float min,float max);

float xofaa(float az,float alt);
float yofa(float alt);
float altofy(float y);
float azofxy(float x,float y);

virtual void paintEvent( QPaintEvent *qp );
virtual void mousePressEvent(QMouseEvent *);
virtual void mouseReleaseEvent(QMouseEvent *);
virtual void mouseDoubleClickEvent(QMouseEvent *e);
virtual void mouseMoveEvent(QMouseEvent *);
virtual void mouseEnter(int);
virtual void mouseLeave(int);
virtual void keyPressEvent(QKeyEvent *);
virtual void keyReleaseEvent(QKeyEvent *);
virtual void resizeEvent ( QResizeEvent * );
void setColor(int);

signals:
	void	select(float x,float y, int i,float val, int map);

public slots:
	void addPoint(float x,float y,float val, int map=0);
	void clear();
	void selPoint(int i);
	void selPointMap(int i);
	void saveEPS();
};

inline void TriView::selPoint(int i) { selpoint=i; needupd=1; }
inline void TriView::setColor(int i) { colormode=i; update(); }
#endif
