#include "List.h"
#include <stdlib.h>

List::List()
{
items=(void **)malloc(8*sizeof(void *));
n=0;
na=8;
}

List::~List()
{
free(items);
}

void List::insertObjectAt(void *obj,int nn) {
int i;

if (nn<0) nn=0;
if (nn>n) nn=n;

for (i=n; i>nn; i--) items[i]=items[i-1];
items[nn]=obj;
n++;
if (n==na) { na*=2; items=(void **)realloc(items,sizeof(void *)*na); }
}

void List::addObject(void *obj) {
items[n]=obj;
n++;
if (n==na) { na*=2; items=(void **)realloc(items,sizeof(void *)*na); }
}

void *List::replaceObjectAt(int nr, void *newd) {
void *tmp;

if (this==NULL) return NULL;
if (nr<0||nr>n) return NULL;
if (nr==n) { addObject(newd); return NULL; }
tmp=items[nr];
items[nr]=newd;

return tmp;
}

void List::swap(int a,int b) {
void *tmp;

if (a<0||b<0 ||a>n ||b>n) return;
tmp=items[a];
items[a]=items[b];
items[b]=tmp;
}

void *List::replaceObject(void *obj,void *newd)
{
int i;

if (this==NULL || (i=indexOf(obj))<0) return NULL;
items[i]=newd;

return obj;
}

void List::removeObject(void *obj)
{
int i;

if (this==NULL || (i=indexOf(obj))<0) return;
removeObjectAt(i);
return;
}

void *List::removeObjectAt(int nn)
{
void *ret;
int i;

if (this==NULL || nn<0 || nn>=n) return NULL;

ret=items[nn];
for (i=nn; i<n; i++) items[i]=items[i+1];
n--;
return ret;
}

void *List::objectAt(int nn)
{
if (this==NULL || nn<0 || nn>=n) return NULL;
return items[nn];
}

int List::count()
{
return n;
}

int List::indexOf(void *obj)
{
int i;

if (this==NULL) return -1;
for (i=0; i<n; i++) if (obj==items[i]) return i;

return -1;
}

void List::empty()
{
n=0;
}

void List::addObjects(List *list)
{
void *obj;
int i;

for (i=0; (obj=list->objectAt(i))!=NULL; i++) addObject(obj);

}

void List::removeObjects(List *list)
{
void *obj;
int i;

for (i=0; (obj=list->objectAt(i))!=NULL; i++) removeObject(obj);

}
