/* ifftsubs.f -- translated by f2c (version of 27 June 1990  8:41:01).
   You must link the resulting object file with the libraries:
	-lF77 -lI77 -lm -lc   (in that order)
*/

//#include "f2c.h"
#include <math.h>

// f2c defs
typedef int integer;
typedef char *address;
typedef short int shortint;
typedef float real;
typedef double doublereal;
typedef struct { real r, i; } complex;
typedef struct { doublereal r, i; } doublecomplex;
typedef long int logical;
typedef short int shortlogical;
typedef char logical1;
typedef char integer1;
#define TRUE_ (1)
#define FALSE_ (0)

int odfft_(real *array,integer *nx,integer *ny,integer *idir);
int todfft_(real *array,integer *nx,integer *ny,integer *idir);
int threedfft_(real *array,integer *nx,integer *ny,integer *nz, integer *idir);
int invcarr_(real *array,integer *nx,integer *ny);
int fft1d_(complex *a,integer *n, integer *idir);
int hermft_(real *x,real *y,integer *n,integer *dim);
int realft_(real *even,real *odd,integer *n,integer *dim);
int rsymft_(real *x,integer *n,integer *dim);
int sdiad_(real *x,real *y,integer *n,integer *dim);
int inv21_(real *x,real *y,integer *n,integer *d);
int cmplft_(real *x,real *y,integer *n,integer *d);
int srfp_(integer *pts, integer *pmax, integer *twogrp, integer *factor, integer *sym, integer *psym, integer *unsym, logical *error);
int diprp_(integer *pts, integer *sym, integer *psym, integer *unsym, integer *dim, real *x, real *y);
int mdftkd_(integer *n, integer *factor, integer *dim, real *x, real *y);
int r2cftk_(integer *n, integer *m, real *x0, real *y0, real *x1, real *y1, integer *dim);
int r3cftk_(integer *n, integer *m, real *x0, real *y0, real *x1, real *y1, real *x2, real *y2, integer *dim);
int r4cftk_(integer *n, integer *m, real *x0, real *y0, real *x1, real *y1, real *x2, real *y2, real *x3, real *y3, integer *dim);
int r5cftk_(integer *n, integer *m, real *x0, real *y0, real *x1, real *y1, real *x2, real *y2, real *x3, real *y3, real *x4, real *y4, integer *dim);
int r8cftk_(integer *n, integer *m, real *x0, real *y0, real *x1, real *y1, real *x2, real *y2, real *x3, real *y3, real *x4, real *y4, real *x5, real *y5, real *x6, real *y6, real *x7, real *y7, integer *dim); 
int rpcftk_(integer *n, integer *m, integer *p, integer *r, real *x, real *y, integer *dim);

/* *ODFFT.FOR******************************************************* */

/* 	Performs NY 1-D FFT'S in place. Uses Lynn Ten Eyck's FFT routines. */
/* 	Thus only restrictions are NX MUST be EVEN & max prime factor =19. */

/* 	Origin is at first point in each strip */
/* 	A Normalization factor is applied during ALL transformations */

/* 	For Real/complex or Complex/real: */
/* 		Only the unique portion of the Transform is written */
/* 		DIMENSION ARRAY(NX+2,NY) */

/* 	For Complex/complex */
/* 		The entire Transform is written */
/* 		COMPLEX ARRAY(NX,NY) */


/* 	IDIR =  0 Foward   (Real --> Complex)     exp(+2PIirs) */
/* 	IDIR =  1 Reverse  (Complex --> Real)	  exp(-2PIirs) */
/* 	IDIR = -1 Foward   (Complex --> Complex)  exp(+2PIirs) */
/* 	IDIR = -2 Reverse  (Complex --> Complex)  exp(-2PIirs) */


/* 	Version 1.00	Apr 19 1982		DAA */
/* 	Version 1.01	Nov 23 1982		DAA */
/*       Update 27-Sept-1990 MFS no changes */
/*       in this file except to delete BIGFFT from it because it is not */
/*       used anymore, to add GIANTFFT which replaces it, and to */
/*       incorporate RETWKSIZE, which is currently a standalone subroutine */
/*       RETWKSIZE does not have to be added anymore. */


/* Subroutine */ int odfft_(real *array,integer *nx,integer *ny,integer *idir)
{
    /* System generated locals */
    integer i_1;

    /* Builtin functions */

    /* Local variables */
    static integer idim[5], j, index, iy;
    static real onevol;
    static integer nx2, nxt, nxm1, nxo2, nxp2, nxt1;


    /* Parameter adjustments */
    --array;

    /* Function Body */
    nxo2 = *nx / 2;
    if (nxo2 << 1 == *nx || *idir < 0) {
	goto L1;
    }
/* 	WRITE(6,1000) NX */
/* 1000	FORMAT(' ODFFT: NX= ',I7,' MUST BE EVEN!!!') */
    return 1;
L1:
    onevol = sqrt((float)1. / *nx);
    switch ((int)(*idir + 3)) {
	case 1:  goto L10;
	case 2:  goto L10;
	case 3:  goto L30;
	case 4:  goto L40;
    }

/* ********      COMPLEX TRANSFORMS COME HERE       ****************** */



/*  SET UP FOR TENEYCK SUBROUTINE CALLS IN TRANSFORM. */

L10:
    nx2 = *nx << 1;
    nxt = nx2 * *ny;
    nxt1 = nxt - 1;
    idim[0] = nxt;
    idim[1] = 2;
    idim[2] = idim[0];
    idim[3] = idim[0];
    idim[4] = nx2;

    cmplft_(&array[1], &array[2], nx, idim);

    if (*idir == -1) {
	goto L15;
    }

/*   SCALE BY 1/VOLUME */

    i_1 = nxt1;
    for (j = 1; j <= i_1; j += 2) {
	array[j] *= onevol;
	array[j + 1] *= onevol;
/* L100: */
    }
    return 0;

/*   TAKE COMPLEX CONJUGATE TO DO FOWARD & SCALE BY 1/VOLUME */

L15:
    i_1 = nxt1;
    for (j = 1; j <= i_1; j += 2) {
	array[j] *= onevol;
	array[j + 1] = -(doublereal)array[j + 1] * onevol;
/* L150: */
    }
    return 0;


/* ********      FOWARD REAL TRANSFORM COMES HERE       ******************
 */


/*  SET UP FOR TRANSFORM */

L30:
    nxp2 = *nx + 2;
    nxt = nxp2 * *ny;
    idim[0] = nxt;
    idim[1] = 2;
    idim[2] = idim[0];
    idim[3] = idim[0];
    idim[4] = nxp2;

    realft_(&array[1], &array[2], &nxo2, idim);

/*    NORMALIZE DATA */

    i_1 = nxt;
    for (j = 1; j <= i_1; ++j) {
	array[j] *= onevol;
/* L200: */
    }

    return 0;

/*********      INVERSE HERMITE TRANSFORM COMES HERE       **************
*****/


/*  SET UP FOR TRANSFORM */

L40:
    nxp2 = *nx + 2;
    nxt = nxp2 * *ny;
    nxm1 = *nx - 1;
    idim[0] = nxt;
    idim[1] = 2;
    idim[2] = idim[0];
    idim[3] = idim[0];
    idim[4] = nxp2;

/*   NORMALIZE DATA */

    i_1 = nxt;
    for (j = 1; j <= i_1; ++j) {
	array[j] = onevol * array[j];
/* L300: */
    }

/*  CHANGE DATA STORAGE MODE */

    index = 2;
    i_1 = *ny;
    for (iy = 1; iy <= i_1; ++iy) {
	array[index] = array[nxm1 + index];
	index += nxp2;
/* L350: */
    }

    hermft_(&array[1], &array[2], &nxo2, idim);

    return 0;
} /* odfft_ */

/* *TODFFT.FOR******************************************************** */

/* 	TWO-DIMENSIONAL FOURIER TRANSFORM SUBROUTINE FOR IMAGE */
/* 	PROCESSING. DOES BOTH FOWARD & INVERSE TRANSFORMS */
/* 	USES LYNN TENEYCK'S MIXED-RADIX ROUTINES */
/* 	THUS THE ONLY RESTRICTION IS THAT THE IMAGE SIZE BE */
/* 	AN EVEN NUMBER AND HAVE NO PRIME FACTORS LARGER THAN 19!! */

/* 	IDIR  0	FORWARD (Real to complex)  :  exp(+2PIirs) -- conventionally. */
/* 	IDIR  1	INVERSE (Complex to real)  :  exp(-2PIirs) -- conventionally. */
/* 	IDIR -1	INVERSE (Complex to real)  :  exp(+2PIirs) not normally needed */
/* 	IDIR -2      (Complex to complex)  :  exp(+2PIirs) */
/* 	IDIR -3      (Complex to complex)  :  exp(-2PIirs) */

/* 	DATA SET UP AS NY ROWS OF NX NUMBERS */
/* 	NOTE NX,NY ALWAYS REFER TO THE REAL-SPACE IMAGE SIZE */

/**** For Real/Complex and Complex/Real, only the unique part of the transform
*/
/*     is stored and written out, thus requiring only half the storage. */

/*  i.e. NX,NY IMAGE IS TRANSFORMED IN-PLACE INTO NY STRIPS OF */
/* 	NX/2 + 1 COMPLEX FOURIER COEFFICIENTS */
/* 	THE ORIGIN IS LOCATED AT THE FIRST POINT!!! */
/* 	ARRAY MUST BE DIMENSIONED TO ALLOW FOR EXTRA STRIP OF COMPLEX */
/* 	NUMBERS ON OUTPUT. */
/* 	THUS FOR A 300X400 TRANSFORM, ARRAY MUST BE DIMENSIONED: */
/* 	REAL ARRAY(302,400) */

/**** For Complex/Complex the array is dimensioned COMPLEX ARRAY(NX,NY), thus
*/
/*    requiring an array that is of size 2*NX*NY actual numbers.  In this case
,*/
/*     there is no extra strip at all. */

/* 	A NORMALIZATION FACTOR IS APPLIED DURING BOTH  TRANSFORMATIONS */

/* 	VERSION 1.00	OCT 11 1981		DAA */
/* 	VERSION 1.02	APR 19 1982		DAA */
/* 	VERSION 1.03	NOV 23 1982		DAA */
/* 	VERSION 1.04	Jun  4 1987		RH    Complex to complex added. */
/* 	VERSION 1.05	Jun 19 1987		RH    Subroutine INVCARR needed. */

/* Subroutine */ int todfft_(real *array,integer *nx,integer *ny,integer *idir)
{
    /* System generated locals */
    integer i_1;

    /* Builtin functions */

    /* Local variables */
    static integer idim[5], j, index, iy;
    static real onevol;
    static integer nx2, nxt;
    static integer nxm1, nxo2, nxp2, nxt1;


    /* Parameter adjustments */
    --array;

    /* Function Body */
    nxo2 = *nx / 2;
    if (nxo2 << 1 == *nx) {
	goto L1;
    }
/* 	WRITE(6,1000) NX */
/* 1000	FORMAT(' TODFFT: NX= ',I7,' MUST BE EVEN!!!') */
    return 1;
L1:
    nxp2 = *nx + 2;
    nxt = nxp2 * *ny;
    nxt1 = nxt - 1;
    onevol = sqrt((float)1. / (*nx * *ny));
    if (*idir == 0) {

/*********    FORWARD(Real->Complex) TRANSFORMS COME HERE    ********
***********/


/*  SET UP FOR FIRST DIMENSION OF TRANSFORM */

	idim[0] = nxp2 * *ny;
	idim[1] = 2;
	idim[2] = idim[0];
	idim[3] = idim[0];
	idim[4] = nxp2;

	realft_(&array[1], &array[2], &nxo2, idim);

/*  SET UP FOR SECOND DIMENSION OF TRANSFORM */

	idim[1] = nxp2;
	idim[3] = idim[1];
	idim[4] = 2;

	cmplft_(&array[1], &array[2], ny, idim);

/*  TAKE COMPLEX CONJUGATE (TO MAKE PROPER FOWARD TRANSFORM)& SCALE BY
 1/VOLUME*/

	i_1 = nxt1;
	for (j = 1; j <= i_1; j += 2) {
	    array[j] *= onevol;
	    array[j + 1] = -(doublereal)array[j + 1] * onevol;
/* L100: */
	}

	return 0;
    }

    if (*idir == 1 || *idir == -1) {

/* **********        INVERSE TRANSFORM     ******************* */


/*  SET UP FOR FIRST DIMENSION OF TRANSFORM */

/* L50: */
	nxm1 = *nx - 1;
	idim[0] = nxp2 * *ny;
	idim[1] = nxp2;
	idim[2] = idim[0];
	idim[3] = idim[1];
	idim[4] = 2;

/*   TAKE COMPLEX CONJUGATE TO DO INVERSE & SCALE BY 1/VOLUME */

	if (*idir == 1) {
	    goto L60;
	}
	i_1 = nxt1;
	for (j = 1; j <= i_1; j += 2) {
	    array[j] *= onevol;
	    array[j + 1] = -(doublereal)array[j + 1] * onevol;
/* L300: */
	}
	goto L70;

/*   IDIR = 1 JUST SCALE BY 1/VOLUME (FOR STANDARD INVERSE TRANSFORM) 
*/

L60:
	i_1 = nxt1;
	for (j = 1; j <= i_1; j += 2) {
	    array[j] *= onevol;
	    array[j + 1] *= onevol;
/* L400: */
	}

L70:
	cmplft_(&array[1], &array[2], ny, idim);

/*  SET UP FOR SECOND DIMENSION OF TRANSFORM */

	idim[1] = 2;
	idim[3] = idim[0];
	idim[4] = nxp2;

/*    CHANGE DATA STORAGE MODE COMPLEX CONJUGATE DONE BY HERMFT */

	index = 2;
	i_1 = *ny;
	for (iy = 1; iy <= i_1; ++iy) {
	    array[index] = array[nxm1 + index];
	    index += nxp2;
/* L500: */
	}

	hermft_(&array[1], &array[2], &nxo2, idim);

	return 0;
    }

    if (*idir == -2 || *idir == -3) {

/********* (Complex->Complex ... +/-2PIirs) TRANSFORMS COME HERE ****
*************/
/*                (TenEyck program convention is -2PIirs) */

	nx2 = *nx << 1;
	nxt = nx2 * *ny;
	nxt1 = nxt - 1;

/*  SET UP FOR FIRST DIMENSION OF TRANSFORM */

	idim[0] = (*nx << 1) * *ny;
	idim[1] = 2;
	idim[2] = idim[0];
	idim[3] = idim[0];
	idim[4] = *nx << 1;

/*  INVERT STORAGE FOR PROPER TRANSFORM IN FORWARD(+2PIirs) DIRECTION.
 */
	if (*idir == -2) {
	    invcarr_(&array[1], nx, ny);
	}

	cmplft_(&array[1], &array[2], nx, idim);

/*  SET UP FOR SECOND DIMENSION OF TRANSFORM */

	idim[1] = *nx << 1;
	idim[3] = idim[1];
	idim[4] = 2;

	cmplft_(&array[1], &array[2], ny, idim);

/*  TAKE COMPLEX CONJUGATE (TO MAKE PROPER FOWARD TRANSFORM)& SCALE BY
 1/VOLUME*/

	i_1 = nxt1;
	for (j = 1; j <= i_1; j += 2) {
	    array[j] *= onevol;
	    array[j + 1] *= onevol;
/* L800: */
	}

	return 0;
    }
return 0;
} /* todfft_ */

/****************************************************************************
****/
/* 	To invert the storage of a complex array prior to calculation of a */
/* 	complex Fourier transform using Lynn TenEyck's FFT routines, so that */
/*	the transform effectively becomes exp(+2PIirs) instead of exp(-2PIirs),*/
/* 	which is the TenEyck convention. */
/* Subroutine */ int invcarr_(real *array,integer *nx,integer *ny)
{
    /* System generated locals */
    integer i_1, i_2;

    /* Local variables */
    static integer i, j;
    static real brray[10000];
    static integer ia, ib;


    /* Parameter adjustments */
    --array;

    /* Function Body */
    i_1 = *nx;
    for (i = 1; i <= i_1; ++i) {
	i_2 = *ny;
	for (j = 1; j <= i_2; ++j) {
	    ia = (i + (j - 1) * *nx << 1) - 1;
	    ib = (*nx + 2 - i + (*ny + 2 - j - 1) * *nx << 1) - 1;
	    if (i == 1) {
		ib -= *nx << 1;
	    }
	    if (j == 1) {
		ib -= (*nx << 1) * *ny;
	    }
	    brray[ib - 1] = array[ia];
/* L10: */
	    brray[ib] = array[ia + 1];
	}
    }
    i_2 = (*nx << 1) * *ny;
    for (i = 1; i <= i_2; ++i) {
/* L20: */
	array[i] = brray[i - 1];
    }
    return 0;
} /* invcarr_ */

/* *FFT1D.FR*********************************************** */

/*     SIMPLE (NON-OPTIMIZED) SUBROUTINE FOR DOING */
/*     1-DIMENSIONAL FFT'S */
/*     IDIR = 0   FOWARD  TRANSFORM */
/*     IDIR = 1   INVERSE TRANSFORM */

/* Subroutine */ int fft1d_(complex *a,integer *n, integer *idir)
{
    /* Initialized data */

    static real alog2 = (float).69314718;
    static real pi = (float)3.141592653;

    /* System generated locals */
    integer i_1, i_2, i_3, i_4, i_5, i_6;
    doublereal d_1, d_2;
    complex q_1;

    /* Builtin functions */

    /* Local variables */
    static integer log2n, i, j, k, l;
    static complex t, u, w;
    static integer le, ip, le1, nm1;
    static real pl1;
    static integer nv2;
    static real api;

    /* Parameter adjustments */
    --a;

    /* Function Body */

    nv2 = *n / 2;
    nm1 = *n - 1;
    j = 1;
    log2n =(integer) (log((real) (*n)) / alog2 + (float).1);
    i_1 = nm1;
    for (i = 1; i <= i_1; ++i) {
	if (i >= j) {
	    goto L5;
	}
	i_2 = j;
	t.r = a[i_2].r, t.i = a[i_2].i;
	i_2 = j;
	i_3 = i;
	a[i_2].r = a[i_3].r, a[i_2].i = a[i_3].i;
	i_2 = i;
	a[i_2].r = t.r, a[i_2].i = t.i;
L5:
	k = nv2;
L6:
	if (k >= j) {
	    goto L7;
	}
	j -= k;
	k /= 2;
	goto L6;
L7:
	j += k;
/* L100: */
    }

    api = pi;
    if (*idir == 1) {
	api = -(doublereal)pi;
    }
    le = 1;
    i_1 = log2n;
    for (l = 1; l <= i_1; ++l) {
	le1 = le;
	le <<= 1;
	u.r = (float)1., u.i = (float)0.;
	pl1 = api / le1;
	d_1 = cos(pl1);
	d_2 = sin(pl1);
	q_1.r = d_1, q_1.i = d_2;
	w.r = q_1.r, w.i = q_1.i;
	i_2 = le1;
	for (j = 1; j <= i_2; ++j) {
	    i_3 = *n;
	    i_4 = le;
	    for (i = j; i_4 < 0 ? i >= i_3 : i <= i_3; i += i_4) {
		ip = i + le1;
		i_5 = ip;
		q_1.r = a[i_5].r * u.r - a[i_5].i * u.i, q_1.i = a[i_5].r * 
			u.i + a[i_5].i * u.r;
		t.r = q_1.r, t.i = q_1.i;
		i_5 = ip;
		i_6 = i;
		q_1.r = a[i_6].r - t.r, q_1.i = a[i_6].i - t.i;
		a[i_5].r = q_1.r, a[i_5].i = q_1.i;
		i_5 = i;
		i_6 = i;
		q_1.r = a[i_6].r + t.r, q_1.i = a[i_6].i + t.i;
		a[i_5].r = q_1.r, a[i_5].i = q_1.i;
/* L200: */
	    }
	    q_1.r = u.r * w.r - u.i * w.i, q_1.i = u.r * w.i + u.i * w.r;
	    u.r = q_1.r, u.i = q_1.i;
/* L300: */
	}
/* L400: */
    }

    return 0;
} /* fft1d_ */

/* Subroutine */ int hermft_(real *x,real *y,integer *n,integer *dim)
{
    /* System generated locals */
    integer i_1, i_2, i_3, i_4, i_5;

    /* Builtin functions */

    /* Local variables */
    static real twon, a, b, c, d, e, f;
    static integer i, j, k;
    static real angle;
    static integer d2, d3, d4, d5, i0, i1, i2, k1;
    static real twopi;
    static integer nover2;
    static real co, si;
    static integer nt;


/*     HERMITIAN SYMMETRIC FOURIER TRANSFORM */

/*     GIVEN THE UNIQUE TERMS OF A HERMITIAN SYMMETRIC SEQUENCE OF LENGTH 
*/
/*     2N THIS SUBROUTINE CALCULATES THE 2N REAL NUMBERS WHICH ARE ITS */
/*     FOURIER TRANSFORM.  THE EVEN NUMBERED ELEMENTS OF THE TRANSFORM */
/*     (0, 2, 4, . . ., 2N-2) ARE RETURNED IN X AND THE ODD NUMBERED */
/*     ELEMENTS (1, 3, 5, . . ., 2N-1) IN Y. */

/*     A FINITE HERMITIAN SEQUENCE OF LENGTH 2N CONTAINS N + 1 UNIQUE */
/*     REAL NUMBERS AND N - 1 UNIQUE IMAGINARY NUMBERS.  FOR CONVENIENCE 
*/
/*     THE REAL VALUE FOR X(N) IS STORED AT Y(0). */


    /* Parameter adjustments */
    --dim;
    --y;
    --x;

    /* Function Body */
    twopi = (float)6.283185;
    twon = (real) (*n << 1);

    nt = dim[1];
    d2 = dim[2];
    d3 = dim[3];
    d4 = dim[4] - 1;
    d5 = dim[5];

    i_1 = nt;
    i_2 = d3;
    for (i0 = 1; i_2 < 0 ? i0 >= i_1 : i0 <= i_1; i0 += i_2) {
	i1 = i0 + d4;
	i_3 = i1;
	i_4 = d5;
	for (i = i0; i_4 < 0 ? i >= i_3 : i <= i_3; i += i_4) {
	    a = x[i];
	    b = y[i];
	    x[i] = a + b;
	    y[i] = a - b;
/* L100: */
	}
    }

    nover2 = *n / 2 + 1;
    if (nover2 < 2) {
	goto L500;
    }
    i_4 = nover2;
    for (i0 = 2; i0 <= i_4; ++i0) {
	angle = twopi * (real) (i0 - 1) / twon;
	co = cos(angle);
	si = sin(angle);
	k = (*n + 2 - (i0 << 1)) * d2;
	k1 = (i0 - 1) * d2 + 1;
	i_3 = nt;
	i_2 = d3;
	for (i1 = k1; i_2 < 0 ? i1 >= i_3 : i1 <= i_3; i1 += i_2) {
	    i2 = i1 + d4;
	    i_1 = i2;
	    i_5 = d5;
	    for (i = i1; i_5 < 0 ? i >= i_1 : i <= i_1; i += i_5) {
		j = i + k;
		a = x[i] + x[j];
		b = x[i] - x[j];
		c = y[i] + y[j];
		d = y[i] - y[j];
		e = b * co + c * si;
		f = b * si - c * co;
		x[i] = a + f;
		x[j] = a - f;
		y[i] = e + d;
		y[j] = e - d;
/* L200: */
	    }
/* L300: */
	}
/* L400: */
    }

    cmplft_(&x[1], &y[1], n, &dim[1]);

L500:
    return 0;

} /* hermft_ */

/* Subroutine */ int realft_(real *even,real *odd,integer *n,integer *dim)
{
    /* System generated locals */
    integer i_1, i_2, i_3, i_4, i_5;

    /* Builtin functions */

    /* Local variables */
    static real twon, a, b, c, d, e, f;
    static integer i, j, k, l;
    static real angle;
    static integer d2, d3, d4, d5, i0, i1, i2;
    static real twopi;
    static integer nover2;
    static real co, si;
    static integer nt;


/*     REAL FOURIER TRANSFORM */

/*     GIVEN A REAL SEQUENCE OF LENGTH 2N THIS SUBROUTINE CALCULATES THE */
/*     UNIQUE PART OF THE FOURIER TRANSFORM.  THE FOURIER TRANSFORM HAS */
/*     N + 1 UNIQUE REAL PARTS AND N - 1 UNIQUE IMAGINARY PARTS.  SINCE */
/*     THE REAL PART AT X(N) IS FREQUENTLY OF INTEREST, THIS SUBROUTINE */
/*     STORES IT AT X(N) RATHER THAN IN Y(0).  THEREFORE X AND Y MUST BE  */
/*     OF LENGTH N + 1 INSTEAD OF N.  NOTE THAT THIS STORAGE ARRANGEMENT  */
/*     IS DIFFERENT FROM THAT EMPLOYED BY THE HERMITIAN FOURIER TRANSFORM  */
/*     SUBROUTINE. */

/*     FOR CONVENIENCE THE DATA IS PRESENTED IN TWO PARTS, THE FIRST */
/*     CONTAINING THE EVEN NUMBERED REAL TERMS AND THE SECOND CONTAINING */
/*     THE ODD NUMBERED TERMS (NUMBERING STARTING AT 0).  ON RETURN THE */

/*     REAL PART OF THE TRANSFORM REPLACES THE EVEN TERMS AND THE */
/*     IMAGINARY PART OF THE TRANSFORM REPLACES THE ODD TERMS. */


    /* Parameter adjustments */
    --dim;
    --odd;
    --even;

    /* Function Body */
    twopi = (float)6.283185;
    twon = (real) (*n << 1);

    cmplft_(&even[1], &odd[1], n, &dim[1]);

    nt = dim[1];
    d2 = dim[2];
    d3 = dim[3];
    d4 = dim[4] - 1;
    d5 = dim[5];
    nover2 = *n / 2 + 1;

    if (nover2 < 2) {
	goto L400;
    }
    i_1 = nover2;
    for (i = 2; i <= i_1; ++i) {
	angle = twopi * (real) (i - 1) / twon;
	co = cos(angle);
	si = sin(angle);
	i0 = (i - 1) * d2 + 1;
	j = (*n + 2 - (i << 1)) * d2;
	i_2 = nt;
	i_3 = d3;
	for (i1 = i0; i_3 < 0 ? i1 >= i_2 : i1 <= i_2; i1 += i_3) {
	    i2 = i1 + d4;
	    i_4 = i2;
	    i_5 = d5;
	    for (k = i1; i_5 < 0 ? k >= i_4 : k <= i_4; k += i_5) {
		l = k + j;
		a = (even[l] + even[k]) / (float)2.;
		c = (even[l] - even[k]) / (float)2.;
		b = (odd[l] + odd[k]) / (float)2.;
		d = (odd[l] - odd[k]) / (float)2.;
		e = c * si + b * co;
		f = c * co - b * si;
		even[k] = a + e;
		even[l] = a - e;
		odd[k] = f - d;
		odd[l] = f + d;
/* L100: */
	    }
/* L200: */
	}
/* L300: */
    }

L400:
    if (*n < 1) {
	goto L600;
    }
    j = *n * d2;
    i_1 = nt;
    i_3 = d3;
    for (i1 = 1; i_3 < 0 ? i1 >= i_1 : i1 <= i_1; i1 += i_3) {
	i2 = i1 + d4;
	i_2 = i2;
	i_5 = d5;
	for (k = i1; i_5 < 0 ? k >= i_2 : k <= i_2; k += i_5) {
	    l = k + j;
	    even[l] = even[k] - odd[k];
	    odd[l] = (float)0.;
	    even[k] += odd[k];
	    odd[k] = (float)0.;
/* L500: */
	}
    }

L600:
    return 0;

} /* realft_ */

/* Subroutine */ int rsymft_(real *x,integer *n,integer *dim)
{
    /* System generated locals */
    integer i_1, i_2, i_3, i_4, i_5;

    /* Builtin functions */

    /* Local variables */
    static real twon;
    static integer twod2;
    static real a, b, c, d;
    static integer i, j, k, l, m;
    static real angle;
    static integer d1, d2, d3, d4, d5, j0, j1, k0, k1, k2, i0;
    static real twopi;
    static integer i1, i2, nover2, nover4;
    static real co;
    static integer ii, mj, mk, ml, mm;
    static real si;
    static integer nn;


/*     REAL SYMMETRIC MULTIDIMENSIONAL FOURIER TRANSFORM */
/*     N MUST BE A MULTIPLE OF 4.  THE TWO UNIQUE ELEMENTS ARE STORED AT 
*/
/*     X(1) AND X(N+1). */

/*     DECIMATION IN FREQUENCY APPLIED TO A REAL SYMMETRIC SEQUENCE OF */
/*     LENGTH 2N GIVES A REAL SYMMETRIC SEQUENCE OF LENGTH N, THE */
/*     TRANSFORM OF WHICH GIVES THE EVEN NUMBERED FOURIER COEFFICIENTS, */

/*     AND A HERMITIAN SYMMETRIC SEQUENCE OF LENGTH N, THE TRANSFORM OF */

/*     WHICH GIVES THE ODD NUMBERED FOURIER COEFFICIENTS.  THE SUM OF */
/*     THE TWO SEQUENCES IS A HERMITIAN SYMMETRIC SEQUENCE OF LENGTH N, */

/*     WHICH MAY BE STORED IN N/2 COMPLEX LOCATIONS.  THE TRANSFORM OF */
/*     THIS SEQUENCE IS N REAL NUMBERS REPRESENTING THE TERM BY TERM SUM 
*/
/*     OF THE EVEN AND ODD NUMBERED FOURIER COEFFICIENTS.  THIS SYMMETRIC 
*/
/*     SEQUENCE MAY BE SOLVED IF ANY OF THE FOURIER COEFFICIENTS ARE */
/*     KNOWN.  FOR THIS PURPOSE X0, WHICH IS SIMPLY THE SUM OF THE */
/*     ORIGINAL SEQUENCE, IS COMPUTED AND SAVED IN X(N+1). */


    /* Parameter adjustments */
    --dim;
    --x;

    /* Function Body */
    if (*n == 1) {
	goto L1300;
    }
    nover2 = *n / 2;
    nover4 = *n / 4;
    if (nover4 << 2 != *n) {
	goto L1400;
    }
    d1 = dim[1];
    d2 = dim[2];
    d3 = dim[3];
    d4 = dim[4] - 1;
    d5 = dim[5];
    twopi = (float)6.283185;
    twon = (real) (*n << 1);
    twod2 = d2 << 1;

    k0 = *n * d2 + 1;
    i_1 = d1;
    i_2 = d3;
    for (k1 = k0; i_2 < 0 ? k1 >= i_1 : k1 <= i_1; k1 += i_2) {
	k2 = k1 + d4;
	i_3 = k2;
	i_4 = d5;
	for (k = k1; i_4 < 0 ? k >= i_3 : k <= i_3; k += i_4) {
	    x[k] /= (float)2.;
/* L100: */
	}
    }

    i_4 = nover2;
    for (i = 2; i <= i_4; ++i) {
	angle = twopi * (real) (i - 1) / twon;
	co = cos(angle);
	si = sin(angle);
	k0 = (i - 1) * d2 + 1;
	j0 = (*n + 2 - (i << 1)) * d2;
	j1 = (*n + 1 - i) * d2;
	i_3 = d1;
	i_2 = d3;
	for (k1 = k0; i_2 < 0 ? k1 >= i_3 : k1 <= i_3; k1 += i_2) {
	    k2 = k1 + d4;
	    i_1 = k2;
	    i_5 = d5;
	    for (k = k1; i_5 < 0 ? k >= i_1 : k <= i_1; k += i_5) {
		l = k + j0;
		nn = k + j1;
		a = x[l] + x[k];
		b = x[l] - x[k];
		x[k] = a - b * co;
		x[l] = b * si;
		x[nn] += a;
/* L200: */
	    }
	}
/* L300: */
    }

    if (nover4 == 1) {
	goto L600;
    }
    j0 = nover4 - 1;
    i_4 = j0;
    for (i = 1; i <= i_4; ++i) {
	k0 = (nover2 + i) * d2 + 1;
	j1 = (nover2 - (i << 1)) * d2;
	i_5 = d1;
	i_1 = d3;
	for (k1 = k0; i_1 < 0 ? k1 >= i_5 : k1 <= i_5; k1 += i_1) {
	    k2 = k1 + d4;
	    i_2 = k2;
	    i_3 = d5;
	    for (k = k1; i_3 < 0 ? k >= i_2 : k <= i_2; k += i_3) {
		l = k + j1;
		a = x[k];
		x[k] = x[l];
		x[l] = a;
/* L400: */
	    }
	}
/* L500: */
    }

L600:
    j0 = nover2 * d2;
    j1 = *n * d2;
    i_4 = d1;
    i_3 = d3;
    for (k1 = 1; i_3 < 0 ? k1 >= i_4 : k1 <= i_4; k1 += i_3) {
	k2 = k1 + d4;
	i_2 = k2;
	i_1 = d5;
	for (k = k1; i_1 < 0 ? k >= i_2 : k <= i_2; k += i_1) {
	    i = k + j0;
	    l = k + j1;
	    x[i] *= (float)2.;
	    x[l] = x[k] + x[i] + x[l] * (float)2.;
	    x[k] *= (float)2.;
/* L700: */
	}
    }

    k = nover2 * d2 + 1;
    hermft_(&x[1], &x[k], &nover2, &dim[1]);

/*     SOLVE THE EQUATIONS FOR ALL OF THE SEQUENCES */

    i0 = 1 - d2;
    mk = nover2 * d2;
    mj = mk + d2;
    ml = *n * d2 + d2;
    mm = ml;
    i_1 = nover4;
    for (ii = 1; ii <= i_1; ++ii) {
	i0 += d2;
	mj -= twod2;
	ml -= twod2;
	mm -= d2;
	i_2 = d1;
	i_3 = d3;
	for (i1 = i0; i_3 < 0 ? i1 >= i_2 : i1 <= i_2; i1 += i_3) {
	    i2 = i1 + d4;
	    i_4 = i2;
	    i_5 = d5;
	    for (i = i1; i_5 < 0 ? i >= i_4 : i <= i_4; i += i_5) {
		j = i + mj;
		k = i + mk;
		l = i + ml;
		m = i + mm;
		a = x[i] - x[m];
		b = x[l] - a;
		c = x[k] - b;
		d = x[j] - c;
		x[i] = x[m];
		x[j] = a;
		x[k] = b;
		x[l] = c;
		x[m] = d;
/* L800: */
	    }
	}
    }

/*     THE RESULTS ARE NOW IN A SCRAMBLED DIGIT REVERSED ORDER, I.E. */
/*     X(1), X(5), X(9), ..., X(10), X(6), X(2), ..., X(3), X(7), X(11), 
*/
/*     ..., X(12), X(8), X(4).  THE FOLLOWING SECTION OF PROGRAM FOLLOWS 
*/
/*     THE PERMUTATION CYCLES AND DOES THE NECESSARY INTERCHANGES. */

    if (nover4 == 1) {
	goto L1300;
    }
    nn = *n - 2;
    i_5 = nn;
    for (i = 1; i <= i_5; ++i) {
	k = i;

L1000:
	k0 = k / 4;
	l = k - (k0 << 2);
	if (l != l / 2 << 1) {
	    k0 = nover4 - 1 - k0;
	}
	k = k0 + l * nover4;
	if (k < i) {
	    goto L1000;
	}
	if (k == i) {
	    goto L1200;
	}

	k0 = i * d2 + 1;
	j0 = (k - i) * d2;
	i_4 = d1;
	i_3 = d3;
	for (k1 = k0; i_3 < 0 ? k1 >= i_4 : k1 <= i_4; k1 += i_3) {
	    k2 = k1 + d4;
	    i_2 = k2;
	    i_1 = d5;
	    for (k = k1; i_1 < 0 ? k >= i_2 : k <= i_2; k += i_1) {
		l = k + j0;
		a = x[k];
		x[k] = x[l];
		x[l] = a;
/* L1100: */
	    }
	}
L1200:
	;
    }

L1300:
    return 0;

L1400:
/*      WRITE (6, 1500) N */
	return 1;

/* 1500 FORMAT (40H0N NOT A MULTIPLE OF 4 IN R SYM FT.  N =,I10//) */

} /* rsymft_ */

/* Subroutine */ int sdiad_(real *x,real *y,integer *n,integer *dim)
{
    /* System generated locals */
    integer i_1, i_2, i_3, i_4, i_5;

    /* Builtin functions */

    /* Local variables */
    static logical fold;
    static real twon, a, c;
    static integer i, j, k, l, m;
    static real s, angle;
    static integer d1, d2, d3, d4, d5, k0, k1, k2;
    static real twopi;
    static integer nover2, mn, nn;


/*     THIS SUBROUTINE COMPUTES HALF THE FOURIER SYNTHESIS ALONG A SCREW 
*/
/*     DIAD LYING ALONG A CRYSTALLOGRAPHIC AXIS GIVEN HALF THE FOURIER */
/*     COEFFICIENTS.  THAT IS, IT ASSUMES THAT F(T) = CONJG(F(-T)) FOR T 
*/
/*     EVEN AND F(T) = -CONJG(F(-T)) FOR T ODD.  N IS THE LENGTH OF THE */

/*     DESIRED HALF OF THE TRANSFORM.  THE LOCATION X(N+1) IS REQUIRED AS 
*/
/*     A SCRATCH LOCATION AND THEREFORE A VALUE IS ALSO RETURNED IN */
/*     X(N+1) AND Y(N+1).  THE VALUE OF THE SECOND HALF OF THE TRANSFORM 
*/
/*     MAY BE GENERATED FROM THE FIRST HALF BY THE FORMULA X(N+T) = X(T), 
*/
/*     Y(N+T) = -Y(T).  IN OTHER WORDS, THE LAST HALF OF THE TRANSFORM IS 
*/
/*     THE COMPLEX CONJUGATE OF THE FIRST HALF. */

/*     THE TRANSFORM IS CALCULATED BY FORMING THE SUM OF THE EVEN TERMS */

/*     AND THE ODD TERMS IN PLACE, USING THE SYMMETRY RELATIONS TO */
/*     OBTAIN THE VALUES FOR NEGATIVE SUBSCRIPTS.  THE TRANSFORM OF THE */

/*     RESULTING SEQUENCE MAY BE SEPARATED BY USING THE FACT THAT THE */
/*     TRANSFORM OF THE EVEN TERMS IS REAL, WHILE THE PRODCT OF THE */
/*     TRANSFORM OF THE ODD TERMS AND (COS(PI*T/N) - I*SIN(PI*T/N)) IS */
/*     IMAGINARY.  THE SCRATCH LOCATION IS REQUIRED BECAUSE THE FORMULA */

/*     FOR SEPARATING THE TWO TRANSFORMS BREAKS DOWN WHEN T = N/2. */


    /* Parameter adjustments */
    --dim;
    --y;
    --x;

    /* Function Body */
    nover2 = *n / 2;
    if (nover2 << 1 != *n) {
	goto L700;
    }
    twon = (real) (*n << 1);
    twopi = (float)6.2831852;
    d1 = dim[1];
    d2 = dim[2];
    d3 = dim[3];
    d4 = dim[4] - 1;
    d5 = dim[5];

    k0 = (*n - 1) * d2 + 1;
    i_1 = d1;
    i_2 = d3;
    for (k1 = k0; i_2 < 0 ? k1 >= i_1 : k1 <= i_1; k1 += i_2) {
	k2 = k1 + d4;
	i_3 = k2;
	i_4 = d5;
	for (k = k1; i_4 < 0 ? k >= i_3 : k <= i_3; k += i_4) {
	    l = k + d2;
	    x[l] = x[k];
/* L100: */
	}
    }
    s = (float)1.;
    nn = *n - 2;
    i_4 = nn;
    for (i = 1; i <= i_4; i += 2) {
	s = -(doublereal)s;
	mn = (*n + 1 - i) * d2;
	k0 = (i - 1) * d2 + 1;
	i_3 = d1;
	i_2 = d3;
	for (k1 = k0; i_2 < 0 ? k1 >= i_3 : k1 <= i_3; k1 += i_2) {
	    k2 = k1 + d4;
	    i_1 = k2;
	    i_5 = d5;
	    for (k = k1; i_5 < 0 ? k >= i_1 : k <= i_1; k += i_5) {
		j = k + d2;
		l = k + (d2 << 1);
		m = k + mn;
		x[m] += s * x[j];
		x[k] += x[j];
		x[j] = x[l] - x[j];
		y[k] += y[j];
		y[j] -= y[l];
/* L150: */
	    }
	}
/* L200: */
    }
    k0 = (*n - 2) * d2 + 1;
    i_4 = d1;
    i_5 = d3;
    for (k1 = k0; i_5 < 0 ? k1 >= i_4 : k1 <= i_4; k1 += i_5) {
	k2 = k1 + d4;
	i_1 = k2;
	i_2 = d5;
	for (k = k1; i_2 < 0 ? k >= i_1 : k <= i_1; k += i_2) {
	    l = k + d2;
	    x[k] += x[l];
	    y[k] += y[l];
	    x[l] = -(doublereal)x[l];
/* L250: */
	}
    }

/*     REORDER SCRAMBLED FOURIER COEFFICIENTS */

    i_2 = nn;
    for (i = 1; i <= i_2; ++i) {
	k = i;
L300:
	k <<= 1;
	if (k > *n - 1) {
	    k = (*n << 1) - 1 - k;
	}
	if (k < i) {
	    goto L300;
	}
	if (k == i) {
	    goto L400;
	}
	j = (k - i) * d2;
	k0 = i * d2 + 1;
	i_1 = d1;
	i_5 = d3;
	for (k1 = k0; i_5 < 0 ? k1 >= i_1 : k1 <= i_1; k1 += i_5) {
	    k2 = k1 + d4;
	    i_4 = k2;
	    i_3 = d5;
	    for (k = k1; i_3 < 0 ? k >= i_4 : k <= i_4; k += i_3) {
		l = k + j;
		a = x[k];
		x[k] = x[l];
		x[l] = a;
		a = y[k];
		y[k] = y[l];
		y[l] = a;
/* L350: */
	    }
	}
L400:
	;
    }

    cmplft_(&x[1], &y[1], n, &dim[1]);

    m = nover2 - 1;
    i_2 = m;
    for (i = 1; i <= i_2; ++i) {
	angle = twopi * (real) i / twon;
	c = cos(angle);
	s = sin(angle);
	k0 = i * d2 + 1;
	fold = TRUE_;
	goto L500;

L450:
	c = -(doublereal)c;
	k0 = (*n - i) * d2 + 1;
	fold = FALSE_;

L500:
	i_3 = d1;
	i_4 = d3;
	for (k1 = k0; i_4 < 0 ? k1 >= i_3 : k1 <= i_3; k1 += i_4) {
	    k2 = k1 + d4;
	    i_5 = k2;
	    i_1 = d5;
	    for (k = k1; i_1 < 0 ? k >= i_5 : k <= i_5; k += i_1) {
		a = y[k] / c;
		x[k] += s * a;
		y[k] = a;
/* L550: */
	    }
	}
	if (fold) {
	    goto L450;
	}
/* L600: */
    }

    m = nover2 * d2;
    k0 = m + 1;
    i_2 = d1;
    i_1 = d3;
    for (k1 = k0; i_1 < 0 ? k1 >= i_2 : k1 <= i_2; k1 += i_1) {
	k2 = k1 + d4;
	i_5 = k2;
	i_4 = d5;
	for (k = k1; i_4 < 0 ? k >= i_5 : k <= i_5; k += i_4) {
	    j = k - m;
	    l = k + m;
	    a = x[l] * (float)2.;
	    x[k] += a;
	    y[k] = a;
	    x[l] = x[j];
	    y[l] = -(doublereal)y[j];
/* L650: */
	}
    }

    return 0;

L700:
/*      WRITE (6, 1000) N */
	return 1;

/* 1000 FORMAT (18H0SDIAD N ODD.  N =, I10) */

} /* sdiad_ */

/* Subroutine */ int inv21_(real *x,real *y,integer *n,integer *d)
{
    /* System generated locals */
    integer i_1, i_2, i_3, i_4, i_5;

    /* Builtin functions */

    /* Local variables */
    static real a, b, c;
    static integer i, j, k, l, m;
    static real r, s, c1;
    static integer d1, d2, d3, d4, d5, j1, j2, j3;
    static real s1;
    static integer nover2, kk, ll;
    static real pi;


/*     INVERTS FOURIER TRANSFORM ALONG A SCREW */
/*     DIAD. THE RESULT IS SCALED BY N. */


    /* Parameter adjustments */
    --d;
    --y;
    --x;

    /* Function Body */
    pi = (float)3.141593;

    d1 = d[1];
    d2 = d[2];
    d3 = d[3];
    d4 = d[4] - 1;
    d5 = d[5];

    nover2 = *n / 2;
    ll = *n * d2;
    kk = nover2 * d2;
    i_1 = d1;
    i_2 = d3;
    for (j1 = 1; i_2 < 0 ? j1 >= i_1 : j1 <= i_1; j1 += i_2) {
	j2 = j1 + d4;
	i_3 = j2;
	i_4 = d5;
	for (j = j1; i_4 < 0 ? j >= i_3 : j <= i_3; j += i_4) {
	    l = ll + j;
	    k = kk + j;
	    x[l] = x[j] + x[k];
	    x[k] += y[k];
	    y[l] = (float)0.;
/* L100: */
	    y[k] = (float)0.;
	}
    }

    c1 = cos(pi / (real) (*n));
    s1 = sin(pi / (real) (*n));
    c = (float)1.;
    s = (float)0.;
    i_4 = nover2;
    for (i = 2; i <= i_4; ++i) {
	kk = (*n + 2 - (i << 1)) * d2;
	ll = (*n + 1 - i) * d2;
	r = c * c1 - s * s1;
	s = c * s1 + s * c1;
	c = r;
	j1 = (i - 1) * d2 + 1;
	i_3 = d1;
	i_2 = d3;
	for (j2 = j1; i_2 < 0 ? j2 >= i_3 : j2 <= i_3; j2 += i_2) {
	    j3 = j2 + d4;
	    i_1 = j3;
	    i_5 = d5;
	    for (j = j2; i_5 < 0 ? j >= i_1 : j <= i_1; j += i_5) {
		l = j + ll;
		k = j + kk;
		x[l] = x[l] + x[j] + x[k];
		x[j] += s * y[j];
		x[k] += s * y[k];
		y[j] = c * y[j];
/* L150: */
		y[k] = -(doublereal)c * y[k];
	    }
	}
/* L200: */
    }

    cmplft_(&x[1], &y[1], n, &d[1]);

    i_4 = nover2;
    for (i = 1; i <= i_4; ++i) {
	kk = (*n + 1 - (i << 1)) * d2;
	ll = kk + i * d2;
	j1 = (i - 1) * d2 + 1;
	i_5 = d1;
	i_1 = d3;
	for (j2 = j1; i_1 < 0 ? j2 >= i_5 : j2 <= i_5; j2 += i_1) {
	    j3 = j2 + d4;
	    i_2 = j3;
	    i_3 = d5;
	    for (j = j2; i_3 < 0 ? j >= i_2 : j <= i_2; j += i_3) {
		k = j + kk;
		l = j + ll;
		a = x[j] - x[l];
		b = y[j] + y[l];
		x[j] = x[l];
		y[j] = -(doublereal)y[l];
		x[l] = x[k] + a;
		y[l] = y[k] - b;
		x[k] = a;
/* L250: */
		y[k] = b;
	    }
	}
/* L300: */
    }

    m = *n - 2;
    i_4 = m;
    for (i = 1; i <= i_4; ++i) {
	k = i;
L320:
	j = k;
	k = j / 2;
	if (k << 1 != j) {
	    k = *n - 1 - k;
	}
	if ((i_3 = k - i) < 0) {
	    goto L320;
	} else if (i_3 == 0) {
	    goto L400;
	} else {
	    goto L340;
	}
L340:
	kk = (k - i) * d2;
	j1 = i * d2 + 1;
	i_3 = d1;
	i_2 = d3;
	for (j2 = j1; i_2 < 0 ? j2 >= i_3 : j2 <= i_3; j2 += i_2) {
	    j3 = j2 + d4;
	    i_1 = j3;
	    i_5 = d5;
	    for (j = j2; i_5 < 0 ? j >= i_1 : j <= i_1; j += i_5) {
		k = j + kk;
		a = x[k];
		b = y[k];
		x[k] = x[j];
		y[k] = y[j];
		x[j] = a;
/* L360: */
		y[j] = b;
	    }
	}
L400:
	;
    }

    return 0;

} /* inv21_ */

/* Subroutine */ int cmplft_(real *x,real *y,integer *n,integer *d)
{
    /* Builtin functions */

    /* Local variables */
    static integer pmax;
    static integer psym;
    static logical error;
    static integer unsym[15];
    static integer factor[15], twogrp, sym[15];


/*     COMPLEX FINITE DISCRETE FOURIER TRANSFORM */
/*     TRANSFORMS ONE DIMENSION OF MULTI-DIMENSIONAL DATA */
/*     MODIFIED BY L. F. TEN EYCK FROM A ONE-DIMENSIONAL VERSION WRITTEN 
*/
/*     BY G. T. SANDE, 1969. */

/*     THIS PROGRAM CALCULATES THE TRANSFORM */
/*               (X(T) + I*Y(T))*(COS(2*PI*T/N) - I*SIN(2*PI*T/N)) */

/*     INDEXING -- THE ARRANGEMENT OF THE MULTI-DIMENSIONAL DATA IS */
/*     SPECIFIED BY THE INTEGER ARRAY D, THE VALUES OF WHICH ARE USED AS 
*/
/*     CONTROL PARAMETERS IN DO LOOPS.  WHEN IT IS DESIRED TO COVER ALL */

/*     ELEMENTS OF THE DATA FOR WHICH THE SUBSCRIPT BEING TRANSFORMED HAS 
*/
/*     THE VALUE I0, THE FOLLOWING IS USED. */

/*               I1 = (I0 - 1)*D(2) + 1 */
/*               DO 100 I2 = I1, D(1), D(3) */
/*               I3 = I2 + D(4) - 1 */
/*               DO 100 I = I2, I3, D(5) */
/*                  . */
/*                  . */
/*           100 CONTINUE */

/*     WITH THIS INDEXING IT IS POSSIBLE TO USE A NUMBER OF ARRANGEMENTS 
*/
/*     OF THE DATA, INCLUDING NORMAL FORTRAN COMPLEX NUMBERS (D(5) = 2) */

/*     OR SEPARATE STORAGE OF REAL AND IMAGINARY PARTS. */


/*     P MAX IS THE LARGEST PRIME FACTOR THAT WILL BE TOLERATED BY THIS */

/*     PROGRAM. */
/*     TWO GRP IS THE LARGEST POWER OF TWO THAT IS TREATED AS A SPECIAL */

/*     CASE. */

    /* Parameter adjustments */
    --d;
    --y;
    --x;

    /* Function Body */
    pmax = 19;
    twogrp = 8;

    if (*n <= 1) {
	goto L100;
    }
    srfp_(n, &pmax, &twogrp, factor, sym, &psym, unsym, &error);
    if (error) {
	goto L200;
    }

    mdftkd_(n, factor, &d[1], &x[1], &y[1]);
    diprp_(n, sym, &psym, unsym, &d[1], &x[1], &y[1]);

L100:
    return 0;

L200:
/*      WRITE (6, 300) N */
	return 1;

/*  300 FORMAT (43H0INVALID NUMBER OF POINTS FOR CMPL FT.  N =, I10//) */

} /* cmplft_ */

/* Subroutine */ int srfp_(integer *pts, integer *pmax, integer *twogrp, integer *factor, integer *sym, integer *psym, integer *unsym, logical *error)
{
    /* System generated locals */
    integer i_1;

    /* Local variables */
    static integer nest, ptwo, f, j, n, p, q, r, jj, pp[14], qq[7];

/*     SYMMETRIZED REORDERING FACTORING PROGRAMME */



    /* Parameter adjustments */
    --unsym;
    --sym;
    --factor;

    /* Function Body */
    nest = 14;

    n = *pts;
    *psym = 1;
    f = 2;
    p = 0;
    q = 0;
L100:
    if (n <= 1) {
	goto L500;
    }
    i_1 = *pmax;
    for (j = f; j <= i_1; ++j) {
	if (n == n / j * j) {
	    goto L300;
	}
/* L200: */
    }
    goto L1400;
L300:
    if ((p << 1) + q >= nest) {
	goto L1600;
    }
    f = j;
    n /= f;
    if (n == n / f * f) {
	goto L400;
    }
    ++q;
    qq[q - 1] = f;
    goto L100;
L400:
    n /= f;
    ++p;
    pp[p - 1] = f;
    *psym *= f;
    goto L100;

L500:
    r = 1;
    if (q == 0) {
	r = 0;
    }
    if (p < 1) {
	goto L700;
    }
    i_1 = p;
    for (j = 1; j <= i_1; ++j) {
	jj = p + 1 - j;
	sym[j] = pp[jj - 1];
	factor[j] = pp[jj - 1];
	jj = p + q + j;
	factor[jj] = pp[j - 1];
	jj = p + r + j;
	sym[jj] = pp[j - 1];
/* L600: */
    }
L700:
    if (q < 1) {
	goto L900;
    }
    i_1 = q;
    for (j = 1; j <= i_1; ++j) {
	jj = p + j;
	unsym[j] = qq[j - 1];
	factor[jj] = qq[j - 1];
/* L800: */
    }
/* Computing 2nd power */
    i_1 = *psym;
    sym[p + 1] = *pts / (i_1 * i_1);
L900:
    jj = (p << 1) + q;
    factor[jj + 1] = 0;
    ptwo = 1;
    j = 0;
L1000:
    ++j;
    if (factor[j] == 0) {
	goto L1200;
    }
    if (factor[j] != 2) {
	goto L1000;
    }
    ptwo <<= 1;
    factor[j] = 1;
    if (ptwo >= *twogrp) {
	goto L1100;
    }
    if (factor[j + 1] == 2) {
	goto L1000;
    }
L1100:
    factor[j] = ptwo;
    ptwo = 1;
    goto L1000;
L1200:
    if (p == 0) {
	r = 0;
    }
    jj = (p << 1) + r;
    sym[jj + 1] = 0;
    if (q <= 1) {
	q = 0;
    }
    unsym[q + 1] = 0;
    *error = FALSE_;

L1300:
    return 0;

L1400:
/*      WRITE (6,1500) PMAX,PTS */
    *error = TRUE_;
    goto L1300;
/* 1500 FORMAT (24H0LARGEST FACTOR EXCEEDS ,I3,7H.  N = ,I6,1H.) */

L1600:
/*      WRITE (6,1700) NEST,PTS */
    *error = TRUE_;
    goto L1300;
/* 1700 FORMAT (22H0FACTOR COUNT EXCEEDS ,I3,7H.  N = ,I6,1H.) */

} /* srfp_ */

/* Subroutine */ int diprp_(integer *pts, integer *sym, integer *psym, integer *unsym, integer *dim, real *x, real *y)
{
    /* System generated locals */
    integer i_1, i_2, i_3, i_4, i_5, i_6, i_7, i_8, i_9, i_10, i_11, i_12, 
	    i_13, i_14, i_15, i_16, i_17, i_18, i_19, i_20, i_21, i_22, i_23, 
	    i_24, i_25, i_26, i_27, i_28, i_29, i_30, i_31;
    static integer equiv_25[14], equiv_26[14];

    /* Local variables */
    static integer mods, nest, size, test, mult, a, b, c, d, e, f, g, h, i, j,
	     k, l, m, n, p;
#define s (equiv_25)
    static real t;
#define u (equiv_26)
    static integer delta, p0, p1, p2, p3, p4, p5;
#define al (equiv_26)
#define bl (equiv_26 + 1)
    static integer dk;
#define cl (equiv_26 + 2)
#define dl (equiv_26 + 3)
#define el (equiv_26 + 4)
#define fl (equiv_26 + 5)
    static integer jj;
#define bs (equiv_25 + 1)
    static integer kk, lk;
#define cs (equiv_25 + 2)
#define ds (equiv_25 + 3)
#define es (equiv_25 + 4)
#define fs (equiv_25 + 5)
#define gs (equiv_25 + 6)
#define hs (equiv_25 + 7)
#define is (equiv_25 + 8)
#define js (equiv_25 + 9)
#define ks (equiv_25 + 10)
#define ls (equiv_25 + 11)
    static integer nt;
#define ms (equiv_25 + 12)
#define ns (equiv_25 + 13)
#define gl (equiv_26 + 6)
#define hl (equiv_26 + 7)
#define il (equiv_26 + 8)
#define jl (equiv_26 + 9)
#define kl (equiv_26 + 10)
#define ll (equiv_26 + 11)
#define ml (equiv_26 + 12)
#define nl (equiv_26 + 13)
    static logical onemod;
    static integer modulo[14], punsym, sep;

/*     DOUBLE IN PLACE REORDERING PROGRAMME */




    /* Parameter adjustments */
    --y;
    --x;
    --dim;
    --unsym;
    --sym;

    /* Function Body */
    nest = 14;

    nt = dim[1];
    sep = dim[2];
    p2 = dim[3];
    size = dim[4] - 1;
    p4 = dim[5];
    if (sym[1] == 0) {
	goto L500;
    }
    i_1 = nest;
    for (j = 1; j <= i_1; ++j) {
	u[j - 1] = 1;
	s[j - 1] = 1;
/* L100: */
    }
    n = *pts;
    i_1 = nest;
    for (j = 1; j <= i_1; ++j) {
	if (sym[j] == 0) {
	    goto L300;
	}
	jj = nest + 1 - j;
	u[jj - 1] = n;
	s[jj - 1] = n / sym[j];
	n /= sym[j];
/* L200: */
    }
L300:

    jj = 0;
    i_1 = *al;
    for (a = 1; a <= i_1; ++a) {
	i_2 = *bl;
	i_3 = *bs;
	for (b = a; i_3 < 0 ? b >= i_2 : b <= i_2; b += i_3) {
	    i_4 = *cl;
	    i_5 = *cs;
	    for (c = b; i_5 < 0 ? c >= i_4 : c <= i_4; c += i_5) {
		i_6 = *dl;
		i_7 = *ds;
		for (d = c; i_7 < 0 ? d >= i_6 : d <= i_6; d += i_7) {
		    i_8 = *el;
		    i_9 = *es;
		    for (e = d; i_9 < 0 ? e >= i_8 : e <= i_8; e += i_9) {
			i_10 = *fl;
			i_11 = *fs;
			for (f = e; i_11 < 0 ? f >= i_10 : f <= i_10; f += 
				i_11) {
			    i_12 = *gl;
			    i_13 = *gs;
			    for (g = f; i_13 < 0 ? g >= i_12 : g <= i_12; g +=
				     i_13) {
				i_14 = *hl;
				i_15 = *hs;
				for (h = g; i_15 < 0 ? h >= i_14 : h <= i_14; 
					h += i_15) {
				    i_16 = *il;
				    i_17 = *is;
				    for (i = h; i_17 < 0 ? i >= i_16 : i <= 
					    i_16; i += i_17) {
					i_18 = *jl;
					i_19 = *js;
					for (j = i; i_19 < 0 ? j >= i_18 : j 
						<= i_18; j += i_19) {
					    i_20 = *kl;
					    i_21 = *ks;
					    for (k = j; i_21 < 0 ? k >= i_20 :
						     k <= i_20; k += i_21) {
			  i_22 = *ll;
			  i_23 = *ls;
			  for (l = k; i_23 < 0 ? l >= i_22 : l <= i_22; l += 
				  i_23) {
			      i_24 = *ml;
			      i_25 = *ms;
			      for (m = l; i_25 < 0 ? m >= i_24 : m <= i_24; m 
				      += i_25) {
				  i_26 = *nl;
				  i_27 = *ns;
				  for (n = m; i_27 < 0 ? n >= i_26 : n <= 
					  i_26; n += i_27) {
				      ++jj;
				      if (jj >= n) {
					  goto L400;
				      }
				      delta = (n - jj) * sep;
				      p1 = (jj - 1) * sep + 1;
				      i_28 = nt;
				      i_29 = p2;
				      for (p0 = p1; i_29 < 0 ? p0 >= i_28 : 
					      p0 <= i_28; p0 += i_29) {
					  p3 = p0 + size;
					  i_30 = p3;
					  i_31 = p4;
					  for (p = p0; i_31 < 0 ? p >= i_30 : 
						  p <= i_30; p += i_31) {
			p5 = p + delta;
			t = x[p];
			x[p] = x[p5];
			x[p5] = t;
			t = y[p];
			y[p] = y[p5];
			y[p5] = t;
/* L350: */
					  }
				      }
L400:
				      ;
				  }
			      }
			  }
					    }
					}
				    }
				}
			    }
			}
		    }
		}
	    }
	}
    }

L500:
    if (unsym[1] == 0) {
	goto L1900;
    }
/* Computing 2nd power */
    i_27 = *psym;
    punsym = *pts / (i_27 * i_27);
    mult = punsym / unsym[1];
    test = (unsym[1] * unsym[2] - 1) * mult * *psym;
    lk = mult;
    dk = mult;
    i_27 = nest;
    for (k = 2; k <= i_27; ++k) {
	if (unsym[k] == 0) {
	    goto L700;
	}
	lk *= unsym[k - 1];
	dk /= unsym[k];
	u[k - 1] = (lk - dk) * *psym;
	mods = k;
/* L600: */
    }
L700:
    onemod = mods < 3;
    if (onemod) {
	goto L900;
    }
    i_27 = mods;
    for (j = 3; j <= i_27; ++j) {
	jj = mods + 3 - j;
	modulo[jj - 1] = u[j - 1];
/* L800: */
    }
L900:
    modulo[1] = u[1];
    *jl = (punsym - 3) * *psym;
    *ms = punsym * *psym;

    i_27 = *jl;
    i_26 = *psym;
    for (j = *psym; i_26 < 0 ? j >= i_27 : j <= i_27; j += i_26) {
	k = j;

L1000:
	k *= mult;
	if (onemod) {
	    goto L1200;
	}
	i_25 = mods;
	for (i = 3; i <= i_25; ++i) {
	    k -= k / modulo[i - 1] * modulo[i - 1];
/* L1100: */
	}
L1200:
	if (k >= test) {
	    goto L1300;
	}
	k -= k / modulo[1] * modulo[1];
	goto L1400;
L1300:
	k = k - k / modulo[1] * modulo[1] + modulo[1];
L1400:
	if (k < j) {
	    goto L1000;
	}

	if (k == j) {
	    goto L1700;
	}
	delta = (k - j) * sep;
	i_25 = *psym;
	for (l = 1; l <= i_25; ++l) {
	    i_24 = *pts;
	    i_23 = *ms;
	    for (m = l; i_23 < 0 ? m >= i_24 : m <= i_24; m += i_23) {
		p1 = (m + j - 1) * sep + 1;
		i_22 = nt;
		i_21 = p2;
		for (p0 = p1; i_21 < 0 ? p0 >= i_22 : p0 <= i_22; p0 += i_21) 
			{
		    p3 = p0 + size;
		    i_20 = p3;
		    i_19 = p4;
		    for (jj = p0; i_19 < 0 ? jj >= i_20 : jj <= i_20; jj += 
			    i_19) {
			kk = jj + delta;
			t = x[jj];
			x[jj] = x[kk];
			x[kk] = t;
			t = y[jj];
			y[jj] = y[kk];
			y[kk] = t;
/* L1500: */
		    }
		}
	    }
/* L1600: */
	}
L1700:
/* L1800: */
	;
    }

L1900:
    return 0;
} /* diprp_ */

#undef nl
#undef ml
#undef ll
#undef kl
#undef jl
#undef il
#undef hl
#undef gl
#undef ns
#undef ms
#undef ls
#undef ks
#undef js
#undef is
#undef hs
#undef gs
#undef fs
#undef es
#undef ds
#undef cs
#undef bs
#undef fl
#undef el
#undef dl
#undef cl
#undef bl
#undef al
#undef u
#undef s


/* Subroutine */ int mdftkd_(integer *n, integer *factor, integer *dim, real *x, real *y)
{
    static integer f, m, p, r, s;

/*     MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL DRIVER */



    /* Parameter adjustments */
    --y;
    --x;
    --dim;
    --factor;

    /* Function Body */
    s = dim[2];
    f = 0;
    m = *n;
L100:
    ++f;
    p = factor[f];
    if (p == 0) {
	return 0;
    }
    m /= p;
    r = m * s;
    if (p > 8) {
	goto L700;
    }
    switch ((int)p) {
	case 1:  goto L100;
	case 2:  goto L200;
	case 3:  goto L300;
	case 4:  goto L400;
	case 5:  goto L500;
	case 6:  goto L800;
	case 7:  goto L700;
	case 8:  goto L600;
    }
    goto L800;

L200:
    r2cftk_(n, &m, &x[1], &y[1], &x[r + 1], &y[r + 1], &dim[1]);
    goto L100;

L300:
    r3cftk_(n, &m, &x[1], &y[1], &x[r + 1], &y[r + 1], &x[(r << 1) + 1], &y[(
	    r << 1) + 1], &dim[1]);
    goto L100;

L400:
    r4cftk_(n, &m, &x[1], &y[1], &x[r + 1], &y[r + 1], &x[(r << 1) + 1], &y[(
	    r << 1) + 1], &x[r * 3 + 1], &y[r * 3 + 1], &dim[1]);
    goto L100;

L500:
    r5cftk_(n, &m, &x[1], &y[1], &x[r + 1], &y[r + 1], &x[(r << 1) + 1], &y[(
	    r << 1) + 1], &x[r * 3 + 1], &y[r * 3 + 1], &x[(r << 2) + 1], &y[(
	    r << 2) + 1], &dim[1]);
    goto L100;

L600:
    r8cftk_(n, &m, &x[1], &y[1], &x[r + 1], &y[r + 1], &x[(r << 1) + 1], &y[(
	    r << 1) + 1], &x[r * 3 + 1], &y[r * 3 + 1], &x[(r << 2) + 1], &y[(
	    r << 2) + 1], &x[r * 5 + 1], &y[r * 5 + 1], &x[r * 6 + 1], &y[r * 
	    6 + 1], &x[r * 7 + 1], &y[r * 7 + 1], &dim[1]);
    goto L100;

L700:
    rpcftk_(n, &m, &p, &r, &x[1], &y[1], &dim[1]);
    goto L100;

L800:
/*      WRITE (6, 900) */
    return 0;
/*  900 FORMAT (34H0TRANSFER ERROR DETECTED IN MDFTKD,//) */
} /* mdftkd_ */

/* Subroutine */ int r2cftk_(integer *n, integer *m, real *x0, real *y0, real *x1, real *y1, integer *dim)
{
    /* Initialized data */

    static real twopi = (float)6.283185;

    /* System generated locals */
    integer i_1, i_2, i_3, i_4, i_5, i_6, i_7;

    /* Builtin functions */

    /* Local variables */
    static logical fold;
    static integer size;
    static logical zero;
    static real c;
    static integer j, k, l;
    static real s, angle;
    static integer k0, k1, k2, l1, m2, mover2, kk;
    static real is, iu;
    static integer ns, nt;
    static real rs, ru, fm2;
    static integer mm2, sep;
    static real fjm1;

/*     RADIX 2 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL */


    /* Parameter adjustments */
    --dim;
    --y1;
    --x1;
    --y0;
    --x0;

    /* Function Body */

    nt = dim[1];
    sep = dim[2];
    l1 = dim[3];
    size = dim[4] - 1;
    k2 = dim[5];
    ns = *n * sep;
    m2 = *m << 1;
    fm2 = (real) m2;
    mover2 = *m / 2 + 1;
    mm2 = sep * m2;

    fjm1 = (float)-1.;
    i_1 = mover2;
    for (j = 1; j <= i_1; ++j) {
	fold = j > 1 && j << 1 < *m + 2;
	k0 = (j - 1) * sep + 1;
	fjm1 += (float)1.;
	angle = twopi * fjm1 / fm2;
	zero = angle == (float)0.;
	if (zero) {
	    goto L200;
	}
	c = cos(angle);
	s = sin(angle);
	goto L200;
L100:
	fold = FALSE_;
	k0 = (*m + 1 - j) * sep + 1;
	c = -(doublereal)c;
L200:

	i_2 = ns;
	i_3 = mm2;
	for (kk = k0; i_3 < 0 ? kk >= i_2 : kk <= i_2; kk += i_3) {
	    i_4 = nt;
	    i_5 = l1;
	    for (l = kk; i_5 < 0 ? l >= i_4 : l <= i_4; l += i_5) {
		k1 = l + size;
		i_6 = k1;
		i_7 = k2;
		for (k = l; i_7 < 0 ? k >= i_6 : k <= i_6; k += i_7) {
		    rs = x0[k] + x1[k];
		    is = y0[k] + y1[k];
		    ru = x0[k] - x1[k];
		    iu = y0[k] - y1[k];
		    x0[k] = rs;
		    y0[k] = is;
		    if (zero) {
			goto L300;
		    }
		    x1[k] = ru * c + iu * s;
		    y1[k] = iu * c - ru * s;
		    goto L400;
L300:
		    x1[k] = ru;
		    y1[k] = iu;
L400:
/* L420: */
		    ;
		}
/* L440: */
	    }
/* L500: */
	}
	if (fold) {
	    goto L100;
	}
/* L600: */
    }

    return 0;
} /* r2cftk_ */

/* Subroutine */ int r3cftk_(integer *n, integer *m, real *x0, real *y0, real *x1, real *y1, real *x2, real *y2, integer *dim)
{
    /* Initialized data */

    static real twopi = (float)6.283185;
    static real a = (float)-.5;
    static real b = (float).8660254;

    /* System generated locals */
    integer i_1, i_2, i_3, i_4, i_5, i_6, i_7;

    /* Builtin functions */

    /* Local variables */
    static logical fold;
    static integer size;
    static logical zero;
    static integer j, k, l;
    static real t, angle, c1, c2, i0, i1;
    static integer k0, k1, k2, l1;
    static real i2;
    static integer m3;
    static real r0, s1, s2, r1, r2;
    static integer mover2;
    static real ia, ib, ra, rb;
    static integer kk;
    static real is;
    static integer ns, nt;
    static real rs, fm3;
    static integer mm3, sep;
    static real fjm1;

/*     RADIX 3 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL */


    /* Parameter adjustments */
    --dim;
    --y2;
    --x2;
    --y1;
    --x1;
    --y0;
    --x0;

    /* Function Body */

    nt = dim[1];
    sep = dim[2];
    l1 = dim[3];
    size = dim[4] - 1;
    k2 = dim[5];
    ns = *n * sep;
    m3 = *m * 3;
    fm3 = (real) m3;
    mm3 = sep * m3;
    mover2 = *m / 2 + 1;

    fjm1 = (float)-1.;
    i_1 = mover2;
    for (j = 1; j <= i_1; ++j) {
	fold = j > 1 && j << 1 < *m + 2;
	k0 = (j - 1) * sep + 1;
	fjm1 += (float)1.;
	angle = twopi * fjm1 / fm3;
	zero = angle == (float)0.;
	if (zero) {
	    goto L200;
	}
	c1 = cos(angle);
	s1 = sin(angle);
	c2 = c1 * c1 - s1 * s1;
	s2 = s1 * c1 + c1 * s1;
	goto L200;
L100:
	fold = FALSE_;
	k0 = (*m + 1 - j) * sep + 1;
	t = c1 * a + s1 * b;
	s1 = c1 * b - s1 * a;
	c1 = t;
	t = c2 * a - s2 * b;
	s2 = -(doublereal)c2 * b - s2 * a;
	c2 = t;
L200:

	i_2 = ns;
	i_3 = mm3;
	for (kk = k0; i_3 < 0 ? kk >= i_2 : kk <= i_2; kk += i_3) {
	    i_4 = nt;
	    i_5 = l1;
	    for (l = kk; i_5 < 0 ? l >= i_4 : l <= i_4; l += i_5) {
		k1 = l + size;
		i_6 = k1;
		i_7 = k2;
		for (k = l; i_7 < 0 ? k >= i_6 : k <= i_6; k += i_7) {
		    r0 = x0[k];
		    i0 = y0[k];
		    rs = x1[k] + x2[k];
		    is = y1[k] + y2[k];
		    x0[k] = r0 + rs;
		    y0[k] = i0 + is;
		    ra = r0 + rs * a;
		    ia = i0 + is * a;
		    rb = (x1[k] - x2[k]) * b;
		    ib = (y1[k] - y2[k]) * b;
		    if (zero) {
			goto L300;
		    }
		    r1 = ra + ib;
		    i1 = ia - rb;
		    r2 = ra - ib;
		    i2 = ia + rb;
		    x1[k] = r1 * c1 + i1 * s1;
		    y1[k] = i1 * c1 - r1 * s1;
		    x2[k] = r2 * c2 + i2 * s2;
		    y2[k] = i2 * c2 - r2 * s2;
		    goto L400;
L300:
		    x1[k] = ra + ib;
		    y1[k] = ia - rb;
		    x2[k] = ra - ib;
		    y2[k] = ia + rb;
L400:
/* L420: */
		    ;
		}
/* L440: */
	    }
/* L500: */
	}
	if (fold) {
	    goto L100;
	}
/* L600: */
    }

    return 0;
} /* r3cftk_ */

/* Subroutine */ int r4cftk_(integer *n, integer *m, real *x0, real *y0, real *x1, real *y1, real *x2, real *y2, real *x3, real *y3, integer *dim)
{
    /* Initialized data */

    static real twopi = (float)6.283185;

    /* System generated locals */
    integer i_1, i_2, i_3, i_4, i_5, i_6, i_7;

    /* Builtin functions */

    /* Local variables */
    static logical fold;
    static integer size;
    static logical zero;
    static integer j, k, l;
    static real t, angle, c1, c2, c3, i1;
    static integer k0, k1, k2, l1;
    static real i2, i3;
    static integer m4;
    static real r1, s1, s2, s3, r2, r3;
    static integer mover2, kk, ns, nt;
    static real fm4, is0, is1;
    static integer mm4;
    static real iu0, iu1, rs0, rs1, ru0, ru1;
    static integer sep;
    static real fjm1;

/*     RADIX 4 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL */


    /* Parameter adjustments */
    --dim;
    --y3;
    --x3;
    --y2;
    --x2;
    --y1;
    --x1;
    --y0;
    --x0;

    /* Function Body */

    nt = dim[1];
    sep = dim[2];
    l1 = dim[3];
    size = dim[4] - 1;
    k2 = dim[5];
    ns = *n * sep;
    m4 = *m << 2;
    fm4 = (real) m4;
    mm4 = sep * m4;
    mover2 = *m / 2 + 1;

    fjm1 = (float)-1.;
    i_1 = mover2;
    for (j = 1; j <= i_1; ++j) {
	fold = j > 1 && j << 1 < *m + 2;
	k0 = (j - 1) * sep + 1;
	fjm1 += (float)1.;
	angle = twopi * fjm1 / fm4;
	zero = angle == (float)0.;
	if (zero) {
	    goto L200;
	}
	c1 = cos(angle);
	s1 = sin(angle);
	c2 = c1 * c1 - s1 * s1;
	s2 = s1 * c1 + c1 * s1;
	c3 = c2 * c1 - s2 * s1;
	s3 = s2 * c1 + c2 * s1;
	goto L200;
L100:
	fold = FALSE_;
	k0 = (*m + 1 - j) * sep + 1;
	t = c1;
	c1 = s1;
	s1 = t;
	c2 = -(doublereal)c2;
	t = c3;
	c3 = -(doublereal)s3;
	s3 = -(doublereal)t;
L200:

	i_2 = ns;
	i_3 = mm4;
	for (kk = k0; i_3 < 0 ? kk >= i_2 : kk <= i_2; kk += i_3) {
	    i_4 = nt;
	    i_5 = l1;
	    for (l = kk; i_5 < 0 ? l >= i_4 : l <= i_4; l += i_5) {
		k1 = l + size;
		i_6 = k1;
		i_7 = k2;
		for (k = l; i_7 < 0 ? k >= i_6 : k <= i_6; k += i_7) {
		    rs0 = x0[k] + x2[k];
		    is0 = y0[k] + y2[k];
		    ru0 = x0[k] - x2[k];
		    iu0 = y0[k] - y2[k];
		    rs1 = x1[k] + x3[k];
		    is1 = y1[k] + y3[k];
		    ru1 = x1[k] - x3[k];
		    iu1 = y1[k] - y3[k];
		    x0[k] = rs0 + rs1;
		    y0[k] = is0 + is1;
		    if (zero) {
			goto L300;
		    }
		    r1 = ru0 + iu1;
		    i1 = iu0 - ru1;
		    r2 = rs0 - rs1;
		    i2 = is0 - is1;
		    r3 = ru0 - iu1;
		    i3 = iu0 + ru1;
		    x2[k] = r1 * c1 + i1 * s1;
		    y2[k] = i1 * c1 - r1 * s1;
		    x1[k] = r2 * c2 + i2 * s2;
		    y1[k] = i2 * c2 - r2 * s2;
		    x3[k] = r3 * c3 + i3 * s3;
		    y3[k] = i3 * c3 - r3 * s3;
		    goto L400;
L300:
		    x2[k] = ru0 + iu1;
		    y2[k] = iu0 - ru1;
		    x1[k] = rs0 - rs1;
		    y1[k] = is0 - is1;
		    x3[k] = ru0 - iu1;
		    y3[k] = iu0 + ru1;
L400:
/* L420: */
		    ;
		}
/* L440: */
	    }
/* L500: */
	}
	if (fold) {
	    goto L100;
	}
/* L600: */
    }

    return 0;
} /* r4cftk_ */

/* Subroutine */ int r5cftk_(integer *n, integer *m, real *x0, real *y0, real *x1, real *y1, real *x2, real *y2, real *x3, real *y3, real *x4, real *y4, integer *dim)
{
    /* Initialized data */

    static real twopi = (float)6.283185;
    static real a1 = (float).30901699;
    static real b1 = (float).95105652;
    static real a2 = (float)-.80901699;
    static real b2 = (float).58778525;

    /* System generated locals */
    integer i_1, i_2, i_3, i_4, i_5, i_6, i_7;

    /* Builtin functions */

    /* Local variables */
    static logical fold;
    static integer size;
    static logical zero;
    static integer j, k, l;
    static real t, angle, c1, c2, c3, c4, i0;
    static integer k0, k1, k2, l1;
    static real i1, i2, i3;
    static integer m5;
    static real s1, s2, s3, s4, r0, r1, r2, r3, r4, i4;
    static integer mover2, kk, ns, nt;
    static real ia1, ia2, ib1, ib2, ra1, ra2, rb1, rb2, fm5, is1, is2;
    static integer mm5;
    static real iu1, iu2, rs1, rs2, ru1, ru2;
    static integer sep;
    static real fjm1;

/*     RADIX 5 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL */


    /* Parameter adjustments */
    --dim;
    --y4;
    --x4;
    --y3;
    --x3;
    --y2;
    --x2;
    --y1;
    --x1;
    --y0;
    --x0;

    /* Function Body */

    nt = dim[1];
    sep = dim[2];
    l1 = dim[3];
    size = dim[4] - 1;
    k2 = dim[5];
    ns = *n * sep;
    m5 = *m * 5;
    fm5 = (real) m5;
    mm5 = sep * m5;
    mover2 = *m / 2 + 1;

    fjm1 = (float)-1.;
    i_1 = mover2;
    for (j = 1; j <= i_1; ++j) {
	fold = j > 1 && j << 1 < *m + 2;
	k0 = (j - 1) * sep + 1;
	fjm1 += (float)1.;
	angle = twopi * fjm1 / fm5;
	zero = angle == (float)0.;
	if (zero) {
	    goto L200;
	}
	c1 = cos(angle);
	s1 = sin(angle);
	c2 = c1 * c1 - s1 * s1;
	s2 = s1 * c1 + c1 * s1;
	c3 = c2 * c1 - s2 * s1;
	s3 = s2 * c1 + c2 * s1;
	c4 = c2 * c2 - s2 * s2;
	s4 = s2 * c2 + c2 * s2;
	goto L200;
L100:
	fold = FALSE_;
	k0 = (*m + 1 - j) * sep + 1;
	t = c1 * a1 + s1 * b1;
	s1 = c1 * b1 - s1 * a1;
	c1 = t;
	t = c2 * a2 + s2 * b2;
	s2 = c2 * b2 - s2 * a2;
	c2 = t;
	t = c3 * a2 - s3 * b2;
	s3 = -(doublereal)c3 * b2 - s3 * a2;
	c3 = t;
	t = c4 * a1 - s4 * b1;
	s4 = -(doublereal)c4 * b1 - s4 * a1;
	c4 = t;
L200:

	i_2 = ns;
	i_3 = mm5;
	for (kk = k0; i_3 < 0 ? kk >= i_2 : kk <= i_2; kk += i_3) {
	    i_4 = nt;
	    i_5 = l1;
	    for (l = kk; i_5 < 0 ? l >= i_4 : l <= i_4; l += i_5) {
		k1 = l + size;
		i_6 = k1;
		i_7 = k2;
		for (k = l; i_7 < 0 ? k >= i_6 : k <= i_6; k += i_7) {
		    r0 = x0[k];
		    i0 = y0[k];
		    rs1 = x1[k] + x4[k];
		    is1 = y1[k] + y4[k];
		    ru1 = x1[k] - x4[k];
		    iu1 = y1[k] - y4[k];
		    rs2 = x2[k] + x3[k];
		    is2 = y2[k] + y3[k];
		    ru2 = x2[k] - x3[k];
		    iu2 = y2[k] - y3[k];
		    x0[k] = r0 + rs1 + rs2;
		    y0[k] = i0 + is1 + is2;
		    ra1 = r0 + rs1 * a1 + rs2 * a2;
		    ia1 = i0 + is1 * a1 + is2 * a2;
		    ra2 = r0 + rs1 * a2 + rs2 * a1;
		    ia2 = i0 + is1 * a2 + is2 * a1;
		    rb1 = ru1 * b1 + ru2 * b2;
		    ib1 = iu1 * b1 + iu2 * b2;
		    rb2 = ru1 * b2 - ru2 * b1;
		    ib2 = iu1 * b2 - iu2 * b1;
		    if (zero) {
			goto L300;
		    }
		    r1 = ra1 + ib1;
		    i1 = ia1 - rb1;
		    r2 = ra2 + ib2;
		    i2 = ia2 - rb2;
		    r3 = ra2 - ib2;
		    i3 = ia2 + rb2;
		    r4 = ra1 - ib1;
		    i4 = ia1 + rb1;
		    x1[k] = r1 * c1 + i1 * s1;
		    y1[k] = i1 * c1 - r1 * s1;
		    x2[k] = r2 * c2 + i2 * s2;
		    y2[k] = i2 * c2 - r2 * s2;
		    x3[k] = r3 * c3 + i3 * s3;
		    y3[k] = i3 * c3 - r3 * s3;
		    x4[k] = r4 * c4 + i4 * s4;
		    y4[k] = i4 * c4 - r4 * s4;
		    goto L400;
L300:
		    x1[k] = ra1 + ib1;
		    y1[k] = ia1 - rb1;
		    x2[k] = ra2 + ib2;
		    y2[k] = ia2 - rb2;
		    x3[k] = ra2 - ib2;
		    y3[k] = ia2 + rb2;
		    x4[k] = ra1 - ib1;
		    y4[k] = ia1 + rb1;
L400:
/* L420: */
		    ;
		}
/* L440: */
	    }
/* L500: */
	}
	if (fold) {
	    goto L100;
	}
/* L600: */
    }

    return 0;
} /* r5cftk_ */

/* Subroutine */ int r8cftk_(integer *n, integer *m, real *x0, real *y0, real *x1, real *y1, real *x2, real *y2, real *x3, real *y3, real *x4, real *y4, real *x5,
	 real *y5, real *x6, real *y6, real *x7, real *y7, integer *dim)
{
    /* Initialized data */

    static real twopi = (float)6.283185;
    static real e = (float).70710678;

    /* System generated locals */
    integer i_1, i_2, i_3, i_4, i_5, i_6, i_7;

    /* Builtin functions */

    /* Local variables */
    static logical fold;
    static integer size;
    static logical zero;
    static integer j, k, l;
    static real t, angle, c1, c2, c3, c4, c5, c6, c7;
    static integer k0, k1, k2, l1;
    static real i1, i2, i3, r1, s1;
    static integer m8;
    static real s2, s3, s4, s5, s6, s7, r2, r3, r4, r5, r6, r7, i4, i5, i6, 
	    i7;
    static integer mover2, kk, ns, nt;
    static real fm8, is0, is1, is2, is3, iu0, iu1;
    static integer mm8;
    static real iu2, iu3, rs0, rs1, rs2, rs3, ru0, ru1, ru2, ru3;
    static integer sep;
    static real fjm1, iss0, iss1, isu0, isu1, ius0, ius1, iuu0, iuu1, rss0, 
	    rss1, rsu0, rsu1, rus0, rus1, ruu0, ruu1;

/*     RADIX 8 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL */


    /* Parameter adjustments */
    --dim;
    --y7;
    --x7;
    --y6;
    --x6;
    --y5;
    --x5;
    --y4;
    --x4;
    --y3;
    --x3;
    --y2;
    --x2;
    --y1;
    --x1;
    --y0;
    --x0;

    /* Function Body */

    nt = dim[1];
    sep = dim[2];
    l1 = dim[3];
    size = dim[4] - 1;
    k2 = dim[5];
    ns = *n * sep;
    m8 = *m << 3;
    fm8 = (real) m8;
    mm8 = sep * m8;
    mover2 = *m / 2 + 1;

    fjm1 = (float)-1.;
    i_1 = mover2;
    for (j = 1; j <= i_1; ++j) {
	fold = j > 1 && j << 1 < *m + 2;
	k0 = (j - 1) * sep + 1;
	fjm1 += (float)1.;
	angle = twopi * fjm1 / fm8;
	zero = angle == (float)0.;
	if (zero) {
	    goto L200;
	}
	c1 = cos(angle);
	s1 = sin(angle);
	c2 = c1 * c1 - s1 * s1;
	s2 = s1 * c1 + c1 * s1;
	c3 = c2 * c1 - s2 * s1;
	s3 = s2 * c1 + c2 * s1;
	c4 = c2 * c2 - s2 * s2;
	s4 = s2 * c2 + c2 * s2;
	c5 = c4 * c1 - s4 * s1;
	s5 = s4 * c1 + c4 * s1;
	c6 = c4 * c2 - s4 * s2;
	s6 = s4 * c2 + c4 * s2;
	c7 = c4 * c3 - s4 * s3;
	s7 = s4 * c3 + c4 * s3;
	goto L200;
L100:
	fold = FALSE_;
	k0 = (*m + 1 - j) * sep + 1;
	t = (c1 + s1) * e;
	s1 = (c1 - s1) * e;
	c1 = t;
	t = s2;
	s2 = c2;
	c2 = t;
	t = (-(doublereal)c3 + s3) * e;
	s3 = (c3 + s3) * e;
	c3 = t;
	c4 = -(doublereal)c4;
	t = -(doublereal)(c5 + s5) * e;
	s5 = (-(doublereal)c5 + s5) * e;
	c5 = t;
	t = -(doublereal)s6;
	s6 = -(doublereal)c6;
	c6 = t;
	t = (c7 - s7) * e;
	s7 = -(doublereal)(c7 + s7) * e;
	c7 = t;
L200:

	i_2 = ns;
	i_3 = mm8;
	for (kk = k0; i_3 < 0 ? kk >= i_2 : kk <= i_2; kk += i_3) {
	    i_4 = nt;
	    i_5 = l1;
	    for (l = kk; i_5 < 0 ? l >= i_4 : l <= i_4; l += i_5) {
		k1 = l + size;
		i_6 = k1;
		i_7 = k2;
		for (k = l; i_7 < 0 ? k >= i_6 : k <= i_6; k += i_7) {
		    rs0 = x0[k] + x4[k];
		    is0 = y0[k] + y4[k];
		    ru0 = x0[k] - x4[k];
		    iu0 = y0[k] - y4[k];
		    rs1 = x1[k] + x5[k];
		    is1 = y1[k] + y5[k];
		    ru1 = x1[k] - x5[k];
		    iu1 = y1[k] - y5[k];
		    rs2 = x2[k] + x6[k];
		    is2 = y2[k] + y6[k];
		    ru2 = x2[k] - x6[k];
		    iu2 = y2[k] - y6[k];
		    rs3 = x3[k] + x7[k];
		    is3 = y3[k] + y7[k];
		    ru3 = x3[k] - x7[k];
		    iu3 = y3[k] - y7[k];
		    rss0 = rs0 + rs2;
		    iss0 = is0 + is2;
		    rsu0 = rs0 - rs2;
		    isu0 = is0 - is2;
		    rss1 = rs1 + rs3;
		    iss1 = is1 + is3;
		    rsu1 = rs1 - rs3;
		    isu1 = is1 - is3;
		    rus0 = ru0 - iu2;
		    ius0 = iu0 + ru2;
		    ruu0 = ru0 + iu2;
		    iuu0 = iu0 - ru2;
		    rus1 = ru1 - iu3;
		    ius1 = iu1 + ru3;
		    ruu1 = ru1 + iu3;
		    iuu1 = iu1 - ru3;
		    t = (rus1 + ius1) * e;
		    ius1 = (ius1 - rus1) * e;
		    rus1 = t;
		    t = (ruu1 + iuu1) * e;
		    iuu1 = (iuu1 - ruu1) * e;
		    ruu1 = t;
		    x0[k] = rss0 + rss1;
		    y0[k] = iss0 + iss1;
		    if (zero) {
			goto L300;
		    }
		    r1 = ruu0 + ruu1;
		    i1 = iuu0 + iuu1;
		    r2 = rsu0 + isu1;
		    i2 = isu0 - rsu1;
		    r3 = rus0 + ius1;
		    i3 = ius0 - rus1;
		    r4 = rss0 - rss1;
		    i4 = iss0 - iss1;
		    r5 = ruu0 - ruu1;
		    i5 = iuu0 - iuu1;
		    r6 = rsu0 - isu1;
		    i6 = isu0 + rsu1;
		    r7 = rus0 - ius1;
		    i7 = ius0 + rus1;
		    x4[k] = r1 * c1 + i1 * s1;
		    y4[k] = i1 * c1 - r1 * s1;
		    x2[k] = r2 * c2 + i2 * s2;
		    y2[k] = i2 * c2 - r2 * s2;
		    x6[k] = r3 * c3 + i3 * s3;
		    y6[k] = i3 * c3 - r3 * s3;
		    x1[k] = r4 * c4 + i4 * s4;
		    y1[k] = i4 * c4 - r4 * s4;
		    x5[k] = r5 * c5 + i5 * s5;
		    y5[k] = i5 * c5 - r5 * s5;
		    x3[k] = r6 * c6 + i6 * s6;
		    y3[k] = i6 * c6 - r6 * s6;
		    x7[k] = r7 * c7 + i7 * s7;
		    y7[k] = i7 * c7 - r7 * s7;
		    goto L400;
L300:
		    x4[k] = ruu0 + ruu1;
		    y4[k] = iuu0 + iuu1;
		    x2[k] = rsu0 + isu1;
		    y2[k] = isu0 - rsu1;
		    x6[k] = rus0 + ius1;
		    y6[k] = ius0 - rus1;
		    x1[k] = rss0 - rss1;
		    y1[k] = iss0 - iss1;
		    x5[k] = ruu0 - ruu1;
		    y5[k] = iuu0 - iuu1;
		    x3[k] = rsu0 - isu1;
		    y3[k] = isu0 + rsu1;
		    x7[k] = rus0 - ius1;
		    y7[k] = ius0 + rus1;
L400:
/* L420: */
		    ;
		}
/* L440: */
	    }
/* L500: */
	}
	if (fold) {
	    goto L100;
	}
/* L600: */
    }

    return 0;
} /* r8cftk_ */

/* Subroutine */ int rpcftk_(integer *n, integer *m, integer *p, integer *r, real *x, real *y, integer *dim)
{
    /* Initialized data */

    static real twopi = (float)6.283185;

    /* System generated locals */
    integer x_dim1, x_offset, y_dim1, y_offset, i_1, i_2, i_3, i_4, i_5, i_6, 
	    i_7, i_8, i_9;

    /* Builtin functions */

    /* Local variables */
    static logical fold;
    static integer size;
    static logical zero;
    static real a[18], b[18], c[18];
    static integer j, k, l;
    static real s[18], t;
    static integer u;
    static real angle;
    static integer v, k0, k1, k2, l1;
    static real aa[81]	/* was [9][9] */, bb[81]	/* was [9][9] */;
    static integer mover2;
    static real ia[9], ib[9], ra[9];
    static integer jj;
    static real rb[9], fp;
    static integer kk;
    static real fu, is;
    static integer mp;
    static real iu;
    static integer pm, pp, ns, nt;
    static real rs, ru, xt, yt, fmp;
    static integer sep, mmp;
    static real fjm1;

/*     RADIX PRIME MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL */



    /* Parameter adjustments */
    --dim;
    y_dim1 = *r;
    y_offset = y_dim1 + 1;
    y -= y_offset;
    x_dim1 = *r;
    x_offset = x_dim1 + 1;
    x -= x_offset;

    /* Function Body */

    nt = dim[1];
    sep = dim[2];
    l1 = dim[3];
    size = dim[4] - 1;
    k2 = dim[5];
    ns = *n * sep;
    mover2 = *m / 2 + 1;
    mp = *m * *p;
    fmp = (real) mp;
    mmp = sep * mp;
    pp = *p / 2;
    pm = *p - 1;
    fp = (real) (*p);
    fu = (float)0.;
    i_1 = pp;
    for (u = 1; u <= i_1; ++u) {
	fu += (float)1.;
	angle = twopi * fu / fp;
	jj = *p - u;
	a[u - 1] = cos(angle);
	b[u - 1] = sin(angle);
	a[jj - 1] = a[u - 1];
	b[jj - 1] = -(doublereal)b[u - 1];
/* L100: */
    }
    i_1 = pp;
    for (u = 1; u <= i_1; ++u) {
	i_2 = pp;
	for (v = 1; v <= i_2; ++v) {
	    jj = u * v - u * v / *p * *p;
	    aa[v + u * 9 - 10] = a[jj - 1];
	    bb[v + u * 9 - 10] = b[jj - 1];
/* L200: */
	}
/* L300: */
    }

    fjm1 = (float)-1.;
    i_1 = mover2;
    for (j = 1; j <= i_1; ++j) {
	fold = j > 1 && j << 1 < *m + 2;
	k0 = (j - 1) * sep + 1;
	fjm1 += (float)1.;
	angle = twopi * fjm1 / fmp;
	zero = angle == (float)0.;
	if (zero) {
	    goto L700;
	}
	c[0] = cos(angle);
	s[0] = sin(angle);
	i_2 = pm;
	for (u = 2; u <= i_2; ++u) {
	    c[u - 1] = c[u - 2] * c[0] - s[u - 2] * s[0];
	    s[u - 1] = s[u - 2] * c[0] + c[u - 2] * s[0];
/* L400: */
	}
	goto L700;
L500:
	fold = FALSE_;
	k0 = (*m + 1 - j) * sep + 1;
	i_2 = pm;
	for (u = 1; u <= i_2; ++u) {
	    t = c[u - 1] * a[u - 1] + s[u - 1] * b[u - 1];
	    s[u - 1] = -(doublereal)s[u - 1] * a[u - 1] + c[u - 1] * b[u - 1];

	    c[u - 1] = t;
/* L600: */
	}
L700:

	i_2 = ns;
	i_3 = mmp;
	for (kk = k0; i_3 < 0 ? kk >= i_2 : kk <= i_2; kk += i_3) {
	    i_4 = nt;
	    i_5 = l1;
	    for (l = kk; i_5 < 0 ? l >= i_4 : l <= i_4; l += i_5) {
		k1 = l + size;
		i_6 = k1;
		i_7 = k2;
		for (k = l; i_7 < 0 ? k >= i_6 : k <= i_6; k += i_7) {
		    xt = x[k + x_dim1];
		    yt = y[k + y_dim1];
		    rs = x[k + (x_dim1 << 1)] + x[k + *p * x_dim1];
		    is = y[k + (y_dim1 << 1)] + y[k + *p * y_dim1];
		    ru = x[k + (x_dim1 << 1)] - x[k + *p * x_dim1];
		    iu = y[k + (y_dim1 << 1)] - y[k + *p * y_dim1];
		    i_8 = pp;
		    for (u = 1; u <= i_8; ++u) {
			ra[u - 1] = xt + rs * aa[u - 1];
			ia[u - 1] = yt + is * aa[u - 1];
			rb[u - 1] = ru * bb[u - 1];
			ib[u - 1] = iu * bb[u - 1];
/* L800: */
		    }
		    xt += rs;
		    yt += is;
		    i_8 = pp;
		    for (u = 2; u <= i_8; ++u) {
			jj = *p - u;
			rs = x[k + (u + 1) * x_dim1] + x[k + (jj + 1) * 
				x_dim1];
			is = y[k + (u + 1) * y_dim1] + y[k + (jj + 1) * 
				y_dim1];
			ru = x[k + (u + 1) * x_dim1] - x[k + (jj + 1) * 
				x_dim1];
			iu = y[k + (u + 1) * y_dim1] - y[k + (jj + 1) * 
				y_dim1];
			xt += rs;
			yt += is;
			i_9 = pp;
			for (v = 1; v <= i_9; ++v) {
			    ra[v - 1] += rs * aa[v + u * 9 - 10];
			    ia[v - 1] += is * aa[v + u * 9 - 10];
			    rb[v - 1] += ru * bb[v + u * 9 - 10];
			    ib[v - 1] += iu * bb[v + u * 9 - 10];
/* L900: */
			}
/* L1000: */
		    }
		    x[k + x_dim1] = xt;
		    y[k + y_dim1] = yt;
		    i_8 = pp;
		    for (u = 1; u <= i_8; ++u) {
			jj = *p - u;
			if (zero) {
			    goto L1100;
			}
			xt = ra[u - 1] + ib[u - 1];
			yt = ia[u - 1] - rb[u - 1];
			x[k + (u + 1) * x_dim1] = xt * c[u - 1] + yt * s[u - 
				1];
			y[k + (u + 1) * y_dim1] = yt * c[u - 1] - xt * s[u - 
				1];
			xt = ra[u - 1] - ib[u - 1];
			yt = ia[u - 1] + rb[u - 1];
			x[k + (jj + 1) * x_dim1] = xt * c[jj - 1] + yt * s[jj 
				- 1];
			y[k + (jj + 1) * y_dim1] = yt * c[jj - 1] - xt * s[jj 
				- 1];
			goto L1200;
L1100:
			x[k + (u + 1) * x_dim1] = ra[u - 1] + ib[u - 1];
			y[k + (u + 1) * y_dim1] = ia[u - 1] - rb[u - 1];
			x[k + (jj + 1) * x_dim1] = ra[u - 1] - ib[u - 1];
			y[k + (jj + 1) * y_dim1] = ia[u - 1] + rb[u - 1];
L1200:
/* L1300: */
			;
		    }
/* L1320: */
		}
/* L1340: */
	    }
/* L1400: */
	}
	if (fold) {
	    goto L500;
	}
/* L1500: */
    }

    return 0;
} /* rpcftk_ */

// **************************************************************************
#include <stdio.h>
#include <math.h>
#include "util.h"

// Subroutine  
int threedfft_(real *array,integer *nx,integer *ny, integer *nz, integer *idir)
{
    
int ix, iy, iz;
int *nx2, nxp2, lenrows, numrows, idirp;

float temp[4000];

//   *THREEDFFT.FOR******************************************************** 

//     THREE-DIMENSIONAL FOURIER TRANSFORM SUBROUTINE FOR IMAGE 
//      PROCESSING. DOES BOTH FOWARD & INVERSE TRANSFORMS 
//      USES LYNN TENEYCK'S MIXED-RADIX ROUTINES 
//      THUS THE ONLY RESTRICTION IS THAT THE IMAGE SIZE BE 
//      AN EVEN NUMBER AND HAVE NO PRIME FACTORS LARGER THAN 19!! 

//      IDIR  0 FORWARD (Real to complex)  :  exp(+2PIirs) -- conventionally. 
//      IDIR  1 INVERSE (Complex to real)  :  exp(-2PIirs) -- conventionally. 
//      IDIR -1 INVERSE (Complex to real)  :  exp(+2PIirs) not normally needed 
//      IDIR -2      (Complex to complex)  :  exp(+2PIirs) 
//      IDIR -3      (Complex to complex)  :  exp(-2PIirs) 

//      DATA SET UP AS NY ROWS OF NX NUMBERS  
//      NOTE NX,NY ALWAYS REFER TO THE REAL-SPACE IMAGE SIZE 

//    For Real/Complex and Complex/Real, only the unique part of the transform
//     is stored and written out, thus requiring only half the storage. 

//  i.e. NX,NY,NZ IMAGE IS TRANSFORMED IN-PLACE INTO NY*NZ STRIPS OF 
//      NX/2 + 1 COMPLEX FOURIER COEFFICIENTS 
//      THE ORIGIN IS LOCATED AT THE FIRST POINT!!! 
//      ARRAY MUST BE DIMENSIONED TO ALLOW FOR EXTRA STRIP OF COMPLEX 
//      NUMBERS ON OUTPUT. 
//      THUS FOR A 300X400X500 TRANSFORM, ARRAY MUST BE DIMENSIONED: 
//      REAL ARRAY(302,400,500) 

//   For Complex/Complex the array is dimensioned COMPLEX ARRAY(NX,NY,NZ), thus
//      requiring an array that is of size 2*NX*NY*NZ actual numbers.  In this case,
//     there is no extra strip at all. 

//      A NORMALIZATION FACTOR IS APPLIED DURING BOTH  TRANSFORMATIONS 

//      VERSION 1.00    DEC 11 1997             PRB


nxp2 = *nx +2;

switch (*idir) {
case 0:
// ******************************************************************************

//          CASE 0 = IDIR     FORWARD   REAL to COMPLEX Transform: (e^(+ 2 PI i k r))

// -------------------------------------------------------------------------------
//      Do x transform; real to complex
          lenrows = *nx;
          numrows = (*ny)*(*nz);
          idirp  = 0;

	odfft_(array, &lenrows, &numrows, &idirp);

// ---------------------------------------------------------------------------
//      Do y transform; complex to complex

          lenrows = (*ny) ;
          numrows  = 1;
          idirp  = -1 ;

//      A.  First fix ix, iz; B. extract a row 2* *ny long; C. FFT ; Put it back

        for (ix=0; ix < nxp2; ix+=2) { for (iz=0; iz < *nz; iz++) {
                for (iy=0; iy < *ny; iy++) {
                        temp[2*iy]   =   array[ix    + nxp2*iy + (*ny)*nxp2*iz];
                        temp[2*iy+1] =   array[ix +1 + nxp2*iy + (*ny)*nxp2*iz];
                }  // ends iy

                odfft_(temp, &lenrows, &numrows, &idirp); // transform done; now put it back

                for (iy=0; iy < *ny; iy++) {
                        array[ix +   nxp2*iy + (*ny)*nxp2*iz] = temp[2*iy];
                        array[ix +1+ nxp2*iy + (*ny)*nxp2*iz] = -temp[2*iy+1];
                }  // ends iy
        }} // ends ix, iz


// ---------------------------------------------------------------------------
//      Do z transform; complex to complex

          lenrows = (*nz) ;
          numrows  = 1;
          idirp  = -1 ;

//      A.  First fix ix, iy; B. extract a row 2* *nz long; C. FFT ; Put it back

        for (ix=0; ix < nxp2; ix+=2) { for (iy=0; iy < *ny; iy++) {
                for (iz=0; iz < *nz; iz++) {
                        temp[2*iz]   =   array[ix    + nxp2*iy + (*ny)*nxp2*iz];
                        temp[2*iz+1] =   array[ix +1 + nxp2*iy + (*ny)*nxp2*iz];
                }  // ends iz

                odfft_(temp, &lenrows, &numrows, &idirp); // transform done; now put it back

                for (iz=0; iz < *nz; iz++) {
                        array[ix +   nxp2*iy + (*ny)*nxp2*iz] = temp[2*iz];
                        array[ix +1+ nxp2*iy + (*ny)*nxp2*iz] = temp[2*iz+1];	
                }  // ends iz
        }} // ends ix, iy
	break;
case 1:

// ****************************************************************************************

//          CASE 1 = IDIR (the usual INVERSE)  COMPLEX  to REAL Transform  (e^(- 2 PI i k r))

// ---------------------------------------------------------------------------
//      Do z transform; complex to complex

          lenrows = (*nz) ;
          numrows  = 1;
          idirp  = -2 ;

//      A.  First fix ix, iz; B. extract a row 2* *nz long; C. FFT ; Put it back

        for (ix=0; ix < nxp2; ix+=2) { for (iy=0; iy < *ny; iy++) {
                for (iz=0; iz < *nz; iz++) {
                        temp[2*iz]   =   array[ix    + nxp2*iy + (*ny)*nxp2*iz];
                        temp[2*iz+1] =   array[ix +1 + nxp2*iy + (*ny)*nxp2*iz];
                }  // ends iz

                odfft_(temp, &lenrows, &numrows, &idirp); // transform done; now put it back

                for (iz=0; iz < *nz; iz++) {
                        array[ix +   nxp2*iy + (*ny)*nxp2*iz] = temp[2*iz];
                        array[ix +1+ nxp2*iy + (*ny)*nxp2*iz] = temp[2*iz+1];
                }  // ends iz
        }} // ends ix, iy
// -------------------------------------------------------------------------------
//      Do y transform; complex to complex

          lenrows = (*ny) ;
          numrows  = 1;
          idirp  = -2 ;

//      A.  First fix ix, iy; B. extract a row 2* *ny long; C. FFT ; Put it back

        for (ix=0; ix < nxp2; ix+=2) { for (iz=0; iz < *nz; iz++) {
                for (iy=0; iy < *ny; iy++) {
                        temp[2*iy]   =   array[ix    + nxp2*iy + (*ny)*nxp2*iz];
                        temp[2*iy+1] =   array[ix +1 + nxp2*iy + (*ny)*nxp2*iz];
                }  // ends iy

                odfft_(temp, &lenrows, &numrows, &idirp); // transform done; now put it back

                for (iy=0; iy < *ny; iy++) {
                        array[ix +   nxp2*iy + (*ny)*nxp2*iz] = temp[2*iy];
                        array[ix +1+ nxp2*iy + (*ny)*nxp2*iz] = temp[2*iy+1];
                }  // ends iy
        }} // ends ix, iz

// ---------------------------------------------------------------------------
//      Do x transform; complex to real

          lenrows = *nx ;
          numrows = (*ny)*(*nz) ;
          idirp  = 1 ;

	odfft_(array, &lenrows, &numrows, &idirp);
	break;
case -1:
// CURRENTLY INCORRECT
// ****************************************************************************************

//          CASE -1 = IDIR    (weird INVERSE) COMPLEX to REAL Transform (e^(+ 2 PI i k r))

// -------------------------------------------------------------------------------
//      Do z transform; complex to complex

          lenrows = (*nz) ;
          numrows  = 1;
          idirp  = -2 ;

//      A.  First fix ix, iy; B. extract a row 2* *nz long; C. FFT ; Put it back

        for (ix=0; ix < nxp2; ix+=2) { for (iy=0; iy < *ny; iy++) {
                for (iz=0; iz < *nz; iz++) {
                        temp[2*iz]   =   array[ix    + nxp2*iy + (*ny)*nxp2*iz];
                        temp[2*iz+1] =   array[ix +1 + nxp2*iy + (*ny)*nxp2*iz];
                }  // ends iz

                odfft_(temp, &lenrows, &numrows, &idirp); // transform done; now put it back

                for (iz=0; iz < *nz; iz++) {
                        array[ix +   nxp2*iy + (*ny)*nxp2*iz] = temp[2*iz];
                        array[ix +1+ nxp2*iy + (*ny)*nxp2*iz] = temp[2*iz+1];
                }  // ends iz
        }} // ends ix, iy
// -------------------------------------------------------------------------------
//      Do y transform; complex to complex

          lenrows = (*ny) ;
          numrows  = 1;
          idirp  = -2 ;

//      A.  First fix ix, iz; B. extract a row 2* *ny long; C. FFT ; Put it back

        for (ix=0; ix < nxp2; ix+=2) { for (iz=0; iz < *nz; iz++) {
                for (iy=0; iy < *ny; iy++) {
                        temp[2*iy]   =   array[ix    + nxp2*iy + (*ny)*nxp2*iz];
                        temp[2*iy+1] =   array[ix +1 + nxp2*iy + (*ny)*nxp2*iz];
                }  // ends iy

                odfft_(temp, &lenrows, &numrows, &idirp); // transform done; now put it back

                for (iy=0; iy < *ny; iy++) {
                        array[ix +   nxp2*iy + (*ny)*nxp2*iz] = temp[2*iy];
                        array[ix +1+ nxp2*iy + (*ny)*nxp2*iz] = temp[2*iy+1];
                }  // ends iy
        }} // ends ix, iz

// ---------------------------------------------------------------------------
//      Do x transform; complex to real

           lenrows = nxp2 ;
           numrows = (*ny)*(*nz) ;
           idirp  = 1 ;

        odfft_(array, &lenrows, &numrows, &idirp);
	break;
case -2:
// ****************************************************************************************

//          CASE -2 = IDIR   (usually FORWARD)  COMPLEX to COMPLEX Transform (e^(+ 2 PI i k r))

// -------------------------------------------------------------------------------

//      Do x transform; complex to complex

           lenrows = nxp2 ;
           numrows = (*ny)*(*nz) ;
           idirp  = -2 ;


        odfft_(array, &lenrows, &numrows,&idirp);

// ---------------------------------------------------------------------------
//      Do y transform; complex to complex

          lenrows = 2*(*ny) ;
          numrows  = 1;
          idirp  = -2 ;

//      A.  First fix ix, iz; B. extract a row 2* *ny long; C. FFT ; Put it back

        for (ix=0; ix < nxp2; ix+=2) { for (iz=0; iz < *nz; iz++) {
                for (iy=0; iy < *ny; iy++) {
                        temp[2*iy]   =   array[ix    + nxp2*iy + (*ny)*nxp2*iz];
                        temp[2*iy+1] =   array[ix +1 + nxp2*iy + (*ny)*nxp2*iz];
                }  // ends iy

                odfft_(temp, &lenrows, &numrows, &idirp); // transform done; now put it back

                for (iy=0; iy < *ny; iy++) {
                        array[ix +   nxp2*iy + (*ny)*nxp2*iz] = temp[2*iy];
                        array[ix +1+ nxp2*iy + (*ny)*nxp2*iz] = temp[2*iy+1];
                }  // ends iy
        }} // ends ix, iz


// ---------------------------------------------------------------------------
//      Do z transform; complex to complex

          lenrows = 2*(*nz) ;
          numrows  = 1;
          idirp  = -2 ;

//      A.  First fix ix, iy; B. extract a row 2* *nz long; C. FFT ; Put it back

        for (ix=0; ix < nxp2; ix+=2) { for (iy=0; iy < *ny; iy++) {
                for (iz=0; iz < *nz; iz++) {
                        temp[2*iz]   =   array[ix    + nxp2*iy + (*ny)*nxp2*iz];
                        temp[2*iz+1] =   array[ix +1 + nxp2*iy + (*ny)*nxp2*iz];
                }  // ends iz

                odfft_(temp, &lenrows, &numrows, &idirp); // transform done; now put it back

                for (iz=0; iz < *nz; iz++) {
                        array[ix +   nxp2*iy + (*ny)*nxp2*iz] = temp[2*iy];
                        array[ix +1+ nxp2*iy + (*ny)*nxp2*iz] = temp[2*iy+1];
                }  // ends iz
        }} // ends ix, iy
	break;
case -3:

// ****************************************************************************************

//          CASE -3 = IDIR   (usually Inverse)  COMPLEX to COMPLEX Transform (e^(- 2 PI i k r))

// ----------------------------------------------------------------------------------------

//      Do x transform; complex to complex

           lenrows = nxp2 ;
           numrows = (*ny)*(*nz) ;
           idirp  = -3 ;


        odfft_(array, &lenrows, &numrows,&idirp);

// ---------------------------------------------------------------------------
//      Do y transform; complex to complex

          lenrows = 2*(*ny) ;
          numrows  = 1;
          idirp  = -3 ;

//      A.  First fix ix, iz; B. extract a row 2* *ny long; C. FFT ; Put it back

        for (ix=0; ix < nxp2; ix+=2) { for (iz=0; iz < *nz; iz++) {
                for (iy=0; iy < *ny; iy++) {
                        temp[2*iy]   =   array[ix    + nxp2*iy + (*ny)*nxp2*iz];
                        temp[2*iy+1] =   array[ix +1 + nxp2*iy + (*ny)*nxp2*iz];
                }  // ends iy

                odfft_(temp, &lenrows, &numrows, &idirp); // transform done; now put it back

                for (iy=0; iy < *ny; iy++) {
                        array[ix +   nxp2*iy + (*ny)*nxp2*iz] = temp[2*iy];
                        array[ix +1+ nxp2*iy + (*ny)*nxp2*iz] = temp[2*iy+1];
                }  // ends iy
        }} // ends ix, iz


// ---------------------------------------------------------------------------
//      Do z transform; complex to complex

          lenrows = 2*(*nz) ;
          numrows  = 1;
          idirp  = -3 ;

//      A.  First fix ix, iy; B. extract a row 2* *nz long; C. FFT ; Put it back

        for (ix=0; ix < nxp2; ix+=2) { for (iy=0; iy < *ny; iy++) {
                for (iz=0; iz < *nz; iz++) {
                        temp[2*iz]   =   array[ix    + nxp2*iy + (*ny)*nxp2*iz];
                        temp[2*iz+1] =   array[ix +1 + nxp2*iy + (*ny)*nxp2*iz];
                }  // ends iz

                odfft_(temp, &lenrows, &numrows, &idirp); // transform done; now put it back

                for (iz=0; iz < *nz; iz++) {
                        array[ix +   nxp2*iy + (*ny)*nxp2*iz] = temp[2*iy];
                        array[ix +1+ nxp2*iy + (*ny)*nxp2*iz] = temp[2*iy+1];
                }  // ends iz
        }} // ends ix, iy


// ****************************************************************************************
	break;
}

	return 0;
}
