#include "ImageMxCon.h"
#include <stdlib.h>

#define Inherited ImageMxConData

ImageMxCon::ImageMxCon(QWidget* parent,const char* name):Inherited( parent, name )
{
connect(brt,SIGNAL(valueChanged(int)),SLOT(newBC(int)));
connect(cont,SIGNAL(valueChanged(int)),SLOT(newBC(int)));
connect(invert,SIGNAL(toggled(bool)),SLOT(newInv(bool)));
connect(label,SIGNAL(toggled(bool)),SLOT(newLab(bool)));
connect(label2,SIGNAL(toggled(bool)),SLOT(newLab2(bool)));
connect(bsaveFile,SIGNAL(clicked()),SLOT(doSaveFile()));
connect(bsave,SIGNAL(clicked()),SLOT(doSaveView()));
connect(bprint,SIGNAL(clicked()),SLOT(doPrint()));
connect(modeApp,SIGNAL(clicked()),SLOT(setModeApp()));
connect(modeDel,SIGNAL(clicked()),SLOT(setModeDel()));
connect(modeMove,SIGNAL(clicked()),SLOT(setModeMove()));
connect(scale,SIGNAL(returnPressed()),SLOT(newScale()));
}


ImageMxCon::~ImageMxCon()
{

}

void ImageMxCon::setup(float b,float c, int inv, int lab,int mode) {
	brt->setValue((int)(b*10000));
	cont->setValue((int)(c*10000));
	if (invert<0) invert->hide();
	else invert->setChecked(inv);
	if (lab<0) { label->hide(); label2->hide(); }
	else {
		label->setChecked(lab&1);
		label2->setChecked((lab&2)/2);
	}
	if (mode<0) {
		modeDel->setEnabled(FALSE);
		modeMove->setEnabled(FALSE);
		bsaveFile->hide();
	}
	else {
		if (mode==0) modeApp->setOn(TRUE);
		else if (mode==1) modeDel->setOn(TRUE);
		else if (mode==2) modeMove->setOn(TRUE);
	}
}

void ImageMxCon::doPrint() {
emit print();
}

void ImageMxCon::doSaveFile() {
emit saveFile();
}

void ImageMxCon::doSaveView() {
emit saveImage();
}

void ImageMxCon::newBC(int B) {
float b=(float)brt->value()/10000.0;
float c=(float)cont->value()/10000.0;
emit(setBC(b,c));
//printf("%f %f\n",b,c);
}

void ImageMxCon::newScale() {
float s=atof(scale->text());
if (s>0) emit setScale(s);
}

void ImageMxCon::newInv(bool t) {
emit(invToggle((int)t));
}

void ImageMxCon::newLab(bool l) {
emit(labToggle((int)l));
}

void ImageMxCon::newLab2(bool l) {
emit(lab2Toggle((int)l));
}

void ImageMxCon::setModeApp() {
emit(newMode(0));
}

void ImageMxCon::setModeDel() {
emit(newMode(1));
}

void ImageMxCon::setModeMove() {
emit(newMode(2));
}
