// euler.C 1998 Steve Ludtke

//N euler
//F This program calculates a cross common lines image between 2 source images
//1
//P <input file>	Source file
//P <#1> <#2>		Source file image numbers for the 2 images to process
//P <output file>	Filespec to write the CCL image to
//D This program will take 2 input images and calculate a square image with
//E cross common-line dot products as the pixels in the image. This is an
//E experimental utility used for program testing and design.

#include <stdio.h>
#include <math.h>
#include "EMData.h"
#include "List.h"
#include "util.h"

main(int argc, char *argv[]) {
int i,j,k,nx,nm,n;
List *data;
EMData *d,*d2,*d3;
char s[80];
float f,mean;

appinit(argc,argv);

if (argc<5) { printf("eulerccl\nUsage: eulerccl <input file> <#1> <#2> <output file>\n"); exit(0); }

data=readImages(argv[1],0,-1);

i=atoi(argv[2]);
j=atoi(argv[3]);

d=((EMData*)data->objectAt(i))->copy();
d2=((EMData*)data->objectAt(j))->copy();

d->toCorner();
d2->toCorner();

d3=new EMData();

d3->commonLines(d,d2);

d3->writeMRC(argv[4]);
}
