#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include <time.h>
#include <pthread.h>
#include <ctype.h>
#include "util.h"
#include "EMData.h"

void *cmra(void *fnum);

main(int argc, char *argv[]) {
int i,j,k;
int iter=5,restart=0,mask=-1,imask=-1,pad=0,classiter=8,d3r=0,classfp=0,goodbad=0,precen=0;
int proc=1,lp=0,alito=0,median=0,dot=0,mode=2,msa=0,shrink=1,mra2=0,nep=0;
float ang=7.5,keep=1.2,xfiles=0,appix=0,d3s=0,hard=0,range=90.0,ctfc=0;
char s[1024],ss[1024],*sym=NULL;
EMData *im;
List *data;
pthread_t *thr;
FILE *log;
time_t t;

appinit(argc,argv);

log=fopen("refine.log","a");

if (argc<2) { printf("Usage:\nPut initial model in 'threed.0a.mrc'. Particles should\n\
be in 'start.hed/img'.\n\nrefine <total iter> [proc=<nproc>] [hard=<maxpr>] [precen] [imask=<rad>]\
[sym=<c2,c4,etc>]\n\t[ang=<dang>] [mask=<rad>] [pad=<size>] [classkeep=<sigma coef>] [mra2]\n\
\t[classiter=<iter>] [filt3d=<lp rad>] [3dr[=<range>]] [d3s=<sigmult>] [median]\n\
\t[xfiles=<a/pix>,<volume>,<ali to>] [classfp=<msa#>] [msa=<proj>] [goodbad]\n\
\t[mode=<1-6>] [dot] [ctfc=<res in A>] [shrink=<n>] [noeulerproj]\n"); exit(0); }

int Ref=LOGbegin(argc,argv);
LOG(Ref,"start.hed",LOG_INFILE,NULL);
LOG(Ref,"refine.log",LOG_OUTFILE,NULL);

t=time(0);
if (log) fprintf(log,"******** refine started %s",ctime(&t));
for (i=0; i<argc; i++) fprintf(log,"%s ",argv[i]);
fprintf(log,"\n");

iter=atoi(argv[1]);

for (i=2; i<argc; i++) {
	if (strncmp("proc=",argv[i],5)==0) proc=atoi(&argv[i][5]);
	else if (strncmp("mask=",argv[i],5)==0) mask=atoi(&argv[i][5]);
	else if (strncmp("imask=",argv[i],6)==0) imask=atoi(&argv[i][6]);
	else if (strncmp("mode=",argv[i],5)==0) mode=atoi(&argv[i][5]);
	else if (strncmp("hard=",argv[i],5)==0) hard=atof(&argv[i][5]);
	else if (strncmp("classkeep=",argv[i],10)==0) keep=atof(&argv[i][10]);
	else if (strncmp("classiter=",argv[i],10)==0) classiter=atoi(&argv[i][10]);
	else if (strncmp("pad=",argv[i],4)==0) pad=atoi(&argv[i][4]);
	else if (strncmp("filt3d=",argv[i],7)==0) lp=atoi(&argv[i][7]);
	else if (strncmp("shrink=",argv[i],7)==0) shrink=atoi(&argv[i][7]);
	else if (strncmp("ang=",argv[i],4)==0) ang=atof(&argv[i][4]);
	else if (strncmp("msa=",argv[i],4)==0) msa=atoi(&argv[i][4]);
	else if (strncmp("mra2",argv[i],4)==0) mra2=1;
	else if (strncmp("noeulerproj",argv[i],11)==0) nep=1;
	else if (strncmp("d3s=",argv[i],4)==0) d3s=atof(&argv[i][4]);
	else if (strncmp("3dr",argv[i],3)==0) {
		d3r=1;
		if (argv[i][3]=='=') range=atof(&argv[i][4]);
	}
	else if (strncmp("sym=",argv[i],4)==0) sym=&argv[i][4];
//	else if (strncmp("restart",argv[i],7)==0) restart=1;
	else if (strncmp("precen",argv[i],6)==0) precen=1;
	else if (strncmp("ctfc=",argv[i],5)==0) ctfc=atof(&argv[i][5]);
	else if (strncmp("goodbad",argv[i],7)==0) goodbad=1;
	else if (strncmp("classfp=",argv[i],8)==0) classfp=atoi(&argv[i][8]);
	else if (strncmp("dot",argv[i],3)==0) dot=1;
	else if (strncmp("median",argv[i],6)==0) median=1;
	else if (strncmp("xfiles=",argv[i],7)==0) {
		xfiles=atof(&argv[i][7]);
		sscanf(&argv[i][7]," %f , %f , %d",&appix,&xfiles,&alito);
	}
	else { printf("Unknown option %s\n",argv[i]); exit(1); }
}

thr=(pthread_t *)malloc(sizeof(pthread_t)*proc);

if (xfiles) {
	sprintf(s,"proc3d threed.0a.mrc x.0.mrc clip=%d,%d,%d mask=%d",mask*2,mask*2,mask*2,mask);
	if (log) { t=time(0); fprintf(log,"%s   %s",s,ctime(&t)); fflush(log); }
	system(s);

	sprintf(s,"volume x.0.mrc %f set=%f",appix,xfiles);
	if (log) { t=time(0); fprintf(log,"%s   %s",s,ctime(&t)); fflush(log); }
	
	system(s);
}


for (i=1; i<=iter; i++) {
	t=time(0);
	if (log) { fprintf(log,"Iteration %d beginning at %s",i,ctime(&t)); fflush(log); }
	
// project3d, classesbymra, classalignall
	sprintf(s,"classes.%d.hed",i);
	if (restart || access(s,R_OK)) {
		// project3d
		sprintf(s,"project3d threed.%da.mrc prop=%1.3f mask=%d mode=-1",i-1,ang,mask);
//		if (pad) sprintf(s+strlen(s)," pad=%d",pad);
		if (sym) sprintf(s+strlen(s)," sym=%s",sym);
//		if (mode) sprintf(s+strlen(s)," mode=%d",mode);

		if (log) { t=time(0); fprintf(log,"%s%s\n",ctime(&t),s); fflush(log); }
		system(s);

		if (classfp) {
//			if (access("start.fp",R_OK)) { 
				sprintf(s,"footprintr start%s.hed start.fp",i==1?"":".cen");
				if (log) { t=time(0); fprintf(log,"%s   %s",s,ctime(&t)); fflush(log); } 
				system(s);
//			}
			if (log) { t=time(0); fprintf(log,"footprintr proj.hed proj.fp   %s",ctime(&t)); fflush(log); } 
			system("footprintr proj.hed proj.fp");
			
//			system("msa2 proj.fp start.fp proj.msa.fp start.msa.fp %d",classfp);
			sprintf(s,"msa2 proj.fp start.fp proj.msa.fp start.msa.fp %d",classfp);
			if (log) { t=time(0); fprintf(log,"%s    %s",s,ctime(&t)); fflush(log); } 
			system(s);
//			if (log) { t=time(0); fprintf(log,"msa2 proj.fp start.fp proj.msa.fp start.msa.fp 6   %s",ctime(&t)); fflush(log); } 

			system("classesrefs start.msa.fp proj.msa.fp dot");
			if (log) { t=time(0); fprintf(log,"classesrefs start.msa.fp proj.msa.fp   %s",ctime(&t)); fflush(log); } 			
		}
		else {
		// classesbymra		(uses dot)
			if (proc==1) {
				sprintf(s,"classesbymra  start%s.hed proj.hed split dot imask=%d shrink=%d%s",i==1?"":".cen",imask,shrink,precen?" precen":"");
				if (mra2) s[12]='2';
				if (log) { t=time(0); fprintf(log,"%s   %s",s,ctime(&t)); fflush(log); }
				system(s);
			}
			else {
				for (j=0; j<proc; j++) {
					sprintf(s,"classesbymra start%s.hed proj.hed split num=%d denom=%d dot imask=%d shrink=%d%s%s",i==1?"":".cen",j,proc,imask,shrink,precen?" precen":"",j==0?"":" quiet");
					if (log) { t=time(0); fprintf(log,"%s   %s",s,ctime(&t)); fflush(log); }
					if (pthread_create(&thr[j],NULL,cmra,(void *)s)) {
						printf("Too many processes requested!\n");
						exit(1);
					}
					sleep(1);
				}
				for (j=0; j<proc; j++) pthread_join(thr[j],NULL);
			}
		}
		
		// clear them out so we can collect the new cenetered particles
		unlink("start.cen.hed");
		unlink("start.cen.img");
		
		sprintf(s,"classalignall ref1 finalref saverefs savecen badfile keep=%1.2f %d proc=%d mask=%d imask=%d %s%s%s",
			keep,classiter,proc,mask,imask,median?"median":"",dot?" dot":"",precen?" precen":"");
		if (ctfc!=0) sprintf(s+strlen(s)," ctfc=%f",ctfc);
		if (log) { t=time(0); fprintf(log,"%s   %s",s,ctime(&t)); fflush(log); }
		system(s);

		sprintf(s,"classes.%d.img",i);
		rename("classes.img",s);
		if (log) { t=time(0); fprintf(log,"mv classes.img %s   %s",s,ctime(&t)); fflush(log); }
		sprintf(s,"classes.%d.hed",i);
		rename("classes.hed",s);
		
		system("/bin/rm cls2.???.???");

		for (j=0; j<10000; j++) {
			sprintf(s,"cls%04d.hed",j);
			if (access(s,R_OK)) break;
			sprintf(s,"bcls%04d.hed",j);
			if (access(s,R_OK)) {
				sprintf(ss,"cls2.%04d.hed",j);
				fclose(fopen(ss,"w"));
				sprintf(ss,"cls2.%04d.img",j);
				fclose(fopen(ss,"w"));
				continue;
			}
			sprintf(ss,"cls2.%04d.hed",j);
			rename(s,ss);
			sprintf(s,"bcls%04d.img",j);
			sprintf(ss,"cls2.%04d.img",j);
			rename(s,ss);
		}

		sprintf(s,"classalignall ref1 finalref saverefs savecen badfile cls=2 keep=%1.2f %d proc=%d mask=%d imask=%d %s%s%s",
			keep,classiter,proc,mask,imask,median?"median":"",dot?" dot":"",precen?" precen":"");
		if (ctfc!=0) sprintf(s+strlen(s)," ctfc=%f",ctfc);
		if (log) { t=time(0); fprintf(log,"%s   %s",s,ctime(&t)); fflush(log); }
		system(s);

		sprintf(s,"proc2d classes.hed classes.%d.hed",i);
		system(s);
		if (log) { t=time(0); fprintf(log,"%s   %s",s,ctime(&t)); fflush(log); }

		unlink("classes.hed");
		unlink("classes.img");
		
		// now add the bad images to the end of start.cen.hed
		for (j=0; j<10000; j++) {
			sprintf(s,"bcls2.%04d.hed",j);
			if (access(s,R_OK)) break;
			sprintf(s,"bcls2.%04d.hed",j);
			if (access(s,R_OK)) continue;
			data=readImages(s,1,-1);
			for (k=0; k<data->count(); k++) {
				im=(EMData *)data->objectAt(k);
				im->writeIMAGIC("start.cen.hed",-1);
				delete im;
			}
			delete data;
			unlink(s);
			sprintf(s,"bcls2.%04d.img",j);
			unlink(s);
		}
		
	}

// now reassign euler angles for the class averages
	if (!nep) {
		sprintf(s,"eulerproj classes.%d.hed proj.hed verbose%s",i,precen?" precen":"");
		if (mask>0) sprintf(s+strlen(s)," mask=%d",mask);
		if (imask>0) sprintf(s+strlen(s)," imask=%d",imask);
		system(s);
		if (log) { t=time(0); fprintf(log,"%s   %s",s,ctime(&t)); fflush(log); }
	}

// make3d
	if (!restart) {
		sprintf(s,"threed.%da.mrc",i);
		if (!access(s,R_OK)) { 
			if (log) { fprintf(log,"Iteration %d already complete\n",i); fflush(log); }
			continue;
		}
	}

	if (msa) {
		sprintf(s,"cloud classes.%d.hed classes.msa.hed %d 1",i,msa);
		if (log) { t=time(0); fprintf(log,"%s   %s",s,ctime(&t)); fflush(log); }
		system(s);
	}

	if (d3r) sprintf(s,"make3dr classes.%d.%shed out=threed.%d.mrc mask=%d range=%f %s",i,msa?"msa.":"",i,mask,range,goodbad?"goodbad":"");
	else sprintf(s,"make3d classes.%d.%shed out=threed.%d.mrc mask=%d",i,msa?"msa.":"",i,mask);
	if (hard) sprintf(s+strlen(s)," hard=%1.2f",hard);
	if (d3s) sprintf(s+strlen(s)," keep=%1.2f",d3s);
	if (pad) sprintf(s+strlen(s)," pad=%d",pad);
	if (sym) sprintf(s+strlen(s)," sym=%s",sym);
	if (mode) sprintf(s+strlen(s)," mode=%d",mode);
	else sprintf(s+strlen(s)," mode=2");
	if (log) { t=time(0); fprintf(log,"%s   %s",s,ctime(&t)); fflush(log); }
	system(s);

// proc3d
	sprintf(s,"proc3d threed.%d.mrc threed.%da.mrc mask=%d",i,i,mask);
	if (lp) sprintf(s+strlen(s)," lp=%d",lp);
	if (log) { t=time(0); fprintf(log,"%s   %s",s,ctime(&t)); fflush(log); }
	system(s);
	
	if (xfiles) {
		sprintf(s,"proc3d threed.%da.mrc x.%d.mrc clip=%d,%d,%d",i,i,mask*2,mask*2,mask*2);
		if (log) { t=time(0); fprintf(log,"%s   %s",s,ctime(&t)); fflush(log); }
		system(s);

		if (i>alito) {
			sprintf(s,"align3d x.%0d.mrc x.%d.mrc x.%d.mrc",alito,i,i);
			if (log) { t=time(0); fprintf(log,"%s   %s",s,ctime(&t)); fflush(log); }
			system(s);
		}
		else if (log) fprintf(log,"Alignment skipped\n");
		
		sprintf(s,"volume x.%d.mrc %f set=%f",i,appix,xfiles);
		if (log) { t=time(0); fprintf(log,"%s   %s",s,ctime(&t)); fflush(log); }
		system(s);
	}

	
}

if (log) { t=time(0); fprintf(log,"%s  Refine complete\n",ctime(&t)); }
fclose(log);
LOG(Ref,NULL,LOG_END,NULL);
}

void *cmra(void *s)
{
char ss[1024];

strcpy(ss,(char *)s);
system(ss);
return NULL;
}
