// speedtest.C  8/99  Steve Ludtke

//N speedtest
//F This program runs a set of speed tests on the current machine.
//U speedtest
//D This program runs a set of speed tests in the current computer. It should
//E have at least 1 unloaded processor, and minimal i/o occuring when this
//E is run. It will give a single value which should be generally proportional
//E to how fast refine will run on a given computer. It is a 'real world' test,
//E in that it simulates a variety of actual operations performed by a 
//E refinement procedure. Don't compare values given by speed test in
//E different versions of EMAN, since the underlying routines may be
//E improved with time.

#include <stdio.h>
#include <math.h>
#include "EMData.h"
#include "List.h"
#include "util.h"
#include <time.h>

#define NTT 200
#define CPS	(CLOCKS_PER_SEC)

main() {
int i,j,k;
clock_t t1,t2;
EMData *data[NTT],*tmp;
float *d,ti;

printf("This could take a few minutes. Please be patient.\n");

// initialize 10 megs of data
printf("Initializing\n");
for (i=0; i<NTT; i++) {
	data[i]=new EMData;
	data[i]->setSize(100,100,1);
	d=data[i]->getData();
	
	for (j=0; j<100*100; j++) d[j]=grand(0,1.0);
	
	data[i]->doneData();
}

t1=clock();
for (i=0; i<3; i++) {
	for (j=5; j<NTT; j++) {
		tmp=data[i]->RTFAlign(data[j]);
		delete tmp;
		putchar('.'); fflush(stdout);
	}
putchar('\n');
}
t2=clock();

ti=(t2-t1)/(float)CPS;
printf("\nFor comparison, one 200Mhz R10k processor on an SGI Onyx2 has a sf of 45\n");
printf("A 250Mhz R10k Octane has a SF of 56\n");
printf("A PIII 500 with 8ns SDRAM has a sf of 45\n");
printf("An Alpha 21264? at 500Mhz has a SF of ~115\n");
printf("\nYour machines speed factor = %1.0f\n",10000.0/ti);

}
