// proc2d.C 8/97  Steve Ludtke
// This program performs various processing operations on images and
// sets of images

#include <stdio.h>
#include <math.h>
#include "EMData.h"
#include "List.h"
#include "util.h"

main(int argc, char *argv[]) {
EMData *d,*d2;
float excl=0;
int savecen=0;
float *dt;
int i;

appinit(argc,argv);

if (argc<3) { 
	printf("Calculate structure factor from 2d diffraction pattern\n\
Usage: struc2d <input file> <output file> [exclude=<arc>] [savecen]\n");
	exit(0); 
}

for (i=3; i<argc; i++) {	
	if (strncmp(argv[i],"exclude=",8)==0) excl=atof(&argv[i][8]);
	else if (strncmp(argv[i],"savecen",7)==0) savecen=1;
	else { printf("Unknown option %s\n",argv[i]); exit(1); }
}

d->readImage(argv[1],0);

d->normalize();

// Ok, first we set a threshold and clip to eliminate possible artifacts at high intensity
d2=d->copy();
dt=d2->getData();
for (i=0; i<d2->xSize()*d2->ySize(); i++) {
	if (dt[i]>d2->Sigma()) dt[i]=0;
}
d2->doneData();

// align the image to itself
d2->transAlign(d2,0,0);
d2->rotateAndTranslate();
if (savecen) d2->writeMRC("centered.mrc");

dt=malloc(d2->xSize()*sizeof(float));
d2->calcRadDist(d2->xSize(),1.0,1.0,dt);

FILE *out=fopen(argv[2],"w");


}
