#ifndef COLH
#define COLH

#include "Equation.h"
#include <qobject.h>

#define COL_DATA	1
#define COL_EQN		2
#define COL_RANGE	3
#define COL_REPCYC	4

class DataSet;

class Column : public QObject{
    Q_OBJECT


float *data;
int n,nrep,ncyc,eqch;
char type;
float min,max;
char *ceqn;
Equation *eqn;
DataSet *parent;
QString title;

public:
Column();
~Column();
void setRange(float min,float max,int n);
void setRepCyc(float min,float max,int nr,int nc,int n);
void setData(float *dat=NULL,int n=-1);
void setEqn(const char *eqn,int n,DataSet *par);
void setSize(int n);
int getSize();
float dataAt(int n);
void updateEqn();
float getMin();
float getMax();
const char *getEqn();

float *getData();	// DANGEROUS! not for normal use

signals:
	void	changed();

public slots:
	void	eqChanged();
	void setVar(char *var,double val);
};

inline int Column::getSize() { return n; }
inline float *Column::getData() { 
	if (type==COL_EQN && eqch) { updateEqn(); eqch=0; }
	return data; 
}
inline void Column::setVar(char *var,double val) { 
	if (type==COL_EQN) eqn->setVar(var,val); 
}
inline const char *Column::getEqn() { 
	return ceqn;
}
#endif
