#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <qmultilinedit.h>
#include <qstring.h>
#include <qcstring.h>
#include "Form.h"

Form::Form(QWidget* parent,const char* name) :QScrollView(parent,name) {
viewport()->setPalette(QPalette( QColor(192,192,192) ));
viewport()->setBackgroundMode(QWidget::PaletteBackground);
//setResizePolicy(Manual);
setVScrollBarMode(Auto);
/*QMultiLineEdit *qme = new QMultiLineEdit;
qme->resize(100,50);
addChild(qme,10,120);*/

busy=0;

resize(800,800);
}

Form::~Form() {

}

void Form::parseFile(char *fsp) {
QFile in(fsp);

if (!in.open(IO_ReadOnly)) return;

char *data = (char *)malloc(in.size()+1);
in.readBlock(data,in.size());
data[in.size()]=0;
parseStr(data);
free(data);

}

// line 1 contains window specs (eventually)
// VERY little error tolerance here
// string <Type><label>#<range>#<undef>#<text>#<help>#
void Form::parseStr(char *str) {
char c,*s=str,*s1;
FEntry *fen;
char *lab,*range,*txt,*hlp,*undef;
int x=10,y=5,tp=FEntry::F_NONE;

QFrame *w=new QFrame(viewport());
w->setFrameStyle(Box|Raised);
w->setLineWidth(2);
w->setMidLineWidth(1);
//w->setBackgroundMode(NoBackground);
addChild(w,0,0);

// skip the first line
while (*s!='\n') s++;
s++;

while (1) {
	while (*s && (*s==' ' || *s=='\n' || *s=='\r')) s++;
	if (!*s) break;

	c=*s;
	s++;

	s1=s;
	while (*s1!='#') s1++;
	lab=new char[s1-s+1];
	strncpy(lab,s,s1-s);
	lab[s1-s]=0;
	s=s1+1;
	
	s1=s;
	while (*s1!='#') s1++;
	range=new char[s1-s+1];
	strncpy(range,s,s1-s);
	range[s1-s]=0;
	s=s1+1;

	s1=s;
	while (*s1!='#') s1++;
	undef=new char[s1-s+1];
	strncpy(undef,s,s1-s);
	undef[s1-s]=0;
	s=s1+1;

	s1=s;
	while (*s1!='#') s1++;
	txt=new char[s1-s+1];
	strncpy(txt,s,s1-s);
	txt[s1-s]=0;
	if (txt[s1-s-1]=='\n') txt[s1-s-1]=0;
	s=s1+1;
	
	s1=s;
	while (*s1!='#') s1++;
	hlp=new char[s1-s+1];
	strncpy(hlp,s,s1-s);
	hlp[s1-s]=0;
	s=s1+1;

	switch (c) {
		case 'N': tp=FEntry::F_NONE; break;
		case 'T': tp=FEntry::F_TEXT; break;
		case 'S': tp=FEntry::F_STRING; break;
		case 'F': tp=FEntry::F_FLOAT; break;
		case 'I': tp=FEntry::F_INT; break;
		case 'B': tp=FEntry::F_BUTTON; break;
		case 'L': tp=FEntry::F_LIST; break;
	}
	
	fen=new FEntry(tp,lab,range,txt,hlp,this,0,y);
	
	entry.insert(lab,fen);
	
	y+=fen->height()+8;
	if (fen->width()>x) x=fen->width();
}

resizeContents(x+8,y+8);
w->resize(x+8,y+8);
resize(x+12,y>700?700:y+12);

//printf("%d\n",x);
}

void Form::dumpValToFile(char *fsp) {
FEntry *fe;
FILE *out;
QDictIterator<FEntry> qdi(entry);

out=fopen(fsp,"w");
if (out) {
	while (qdi.current()) {
		fprintf(out,"%s\t%s\n",(const char *)qdi.currentKey(),(const char *)qdi.current()->strValue());
		++qdi;
	}
	fclose(out);
}

}

void Form::readValFromFile(char *fsp) {
FEntry *fe;
FILE *in;
char s[80],t[80],u[80];

in=fopen(fsp,"r");
if (in) {
	while (fgets(s,79,in)) {
		sscanf(s," %s %s",t,u);
		fe=getItem(t);
		if (fe) fe->setStringValue(u);
	}
	fclose(in);
}

}

void Form::change() {
if (busy) return;

if (!sender()) { printf("unknown!\n"); return; }
emit(changed((const char *)sender()->name()));
}

void Form::change(int v) {
if (busy) return;

emit(changed((const char *)sender()->name()));
}

void Form::change(const QString &c) {
if (busy) return;

emit(changed((const char *)c));
}

FEntry *Form::getItem(char *label) {
return entry.find(label);
}

QCString *Form::valFromFile(char *file,char *key) {
FILE *in;
int i;
char l[512],s[256],t[256];

//printf("'%s','%s'\n",file,key);

in=fopen(file,"r");
if (!in) return NULL;

while (fgets(l,511,in) && sscanf(l," %s %s",s,t)>=1 && strcmp(key,s)!=0) ;
fclose(in);

//printf("found '%s','%s'\n",s,t);

if (strcmp(key,s)) return NULL;

return (new QCString(t));
}
