#include <stdio.h>
#include <stdlib.h>
#include "Plot.h"

//#define DEBUG

Plot3d::Plot()
{
initMetaObject();                           // initialize meta object
data=NULL;
cols=(int *)malloc(4*sizeof(int));
ncol=4;
cols[0]=0;
cols[1]=1;
cols[2]=2;
cols[3]=3;
Label=(char *)malloc(1);
Label[0]=0;
lfont=new QFont("times",12);
lmet=new QFontMetrics(*lfont);
}

Plot3d::~Plot()
{
delete lfont;
delete lmet;
free(cols);
free(Label);
}

void Plot3d::dataChanged() { emit changed(); }

void Plot3d::setData(DataSet *dat)
{
if (data) QObject::disconnect(data);
data=dat;
QObject::connect(data,SIGNAL(changed()),this,SLOT(dataChanged()));
}

void Plot3d::setCols(int *c,int n) {
int i;

if (n<=0 || c==NULL) { ncol=0; return; }

cols=(int *)realloc(cols,n*sizeof(int));
for (i=0; i<n; i++) cols[i]=c[i];
ncol=n;
}

void Plot3d::setCols(int c1,int c2,int c3,int c4)
{
cols=(int *)realloc(cols,4*sizeof(int));
cols[0]=c1;
cols[1]=c2;
cols[2]=c3;
cols[3]=c4;
ncol=4;
}

void Plot3d::render(int list,float *mx) {
printf("Plot3d render. Probably a programming error.\n");
return;
}

f3Rect Plot3d::getLimits() {
fRect ret = { 0,0,0,1.0,1.0,1.0 };

if (!data || ncol<2) return ret;

ret.min[0]=data->getColumn(cols[0])->getMin();
ret.max[0]=data->getColumn(cols[0])->getMax();
ret.min[1]=data->getColumn(cols[1])->getMin();
ret.max[1]=data->getColumn(cols[1])->getMax();
ret.min[2]=data->getColumn(cols[2])->getMin();
ret.max[2]=data->getColumn(cols[2])->getMax();

#ifdef DEBUG1
printf("Plot Limit: %f,%f - %f,%f\n",ret.x0,ret.y0,ret.x1,ret.y1);
#endif
return ret;
}
